

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)

/No description available in the introspection data./
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.Handy.Objects.ActionRow
    ( 

-- * Exported types
    ActionRow(..)                           ,
    IsActionRow                             ,
    toActionRow                             ,
    noActionRow                             ,


 -- * Methods
-- ** activate #method:activate#

#if ENABLE_OVERLOADING
    ActionRowActivateMethodInfo             ,
#endif
    actionRowActivate                       ,


-- ** addAction #method:addAction#

#if ENABLE_OVERLOADING
    ActionRowAddActionMethodInfo            ,
#endif
    actionRowAddAction                      ,


-- ** addPrefix #method:addPrefix#

#if ENABLE_OVERLOADING
    ActionRowAddPrefixMethodInfo            ,
#endif
    actionRowAddPrefix                      ,


-- ** getActivatableWidget #method:getActivatableWidget#

#if ENABLE_OVERLOADING
    ActionRowGetActivatableWidgetMethodInfo ,
#endif
    actionRowGetActivatableWidget           ,


-- ** getIconName #method:getIconName#

#if ENABLE_OVERLOADING
    ActionRowGetIconNameMethodInfo          ,
#endif
    actionRowGetIconName                    ,


-- ** getSubtitle #method:getSubtitle#

#if ENABLE_OVERLOADING
    ActionRowGetSubtitleMethodInfo          ,
#endif
    actionRowGetSubtitle                    ,


-- ** getTitle #method:getTitle#

#if ENABLE_OVERLOADING
    ActionRowGetTitleMethodInfo             ,
#endif
    actionRowGetTitle                       ,


-- ** getUseUnderline #method:getUseUnderline#

#if ENABLE_OVERLOADING
    ActionRowGetUseUnderlineMethodInfo      ,
#endif
    actionRowGetUseUnderline                ,


-- ** new #method:new#

    actionRowNew                            ,


-- ** setActivatableWidget #method:setActivatableWidget#

#if ENABLE_OVERLOADING
    ActionRowSetActivatableWidgetMethodInfo ,
#endif
    actionRowSetActivatableWidget           ,


-- ** setIconName #method:setIconName#

#if ENABLE_OVERLOADING
    ActionRowSetIconNameMethodInfo          ,
#endif
    actionRowSetIconName                    ,


-- ** setSubtitle #method:setSubtitle#

#if ENABLE_OVERLOADING
    ActionRowSetSubtitleMethodInfo          ,
#endif
    actionRowSetSubtitle                    ,


-- ** setTitle #method:setTitle#

#if ENABLE_OVERLOADING
    ActionRowSetTitleMethodInfo             ,
#endif
    actionRowSetTitle                       ,


-- ** setUseUnderline #method:setUseUnderline#

#if ENABLE_OVERLOADING
    ActionRowSetUseUnderlineMethodInfo      ,
#endif
    actionRowSetUseUnderline                ,




 -- * Properties
-- ** activatableWidget #attr:activatableWidget#
{- | The activatable widget for this row.

/Since: 0.0.7/
-}
#if ENABLE_OVERLOADING
    ActionRowActivatableWidgetPropertyInfo  ,
#endif
#if ENABLE_OVERLOADING
    actionRowActivatableWidget              ,
#endif
    clearActionRowActivatableWidget         ,
    constructActionRowActivatableWidget     ,
    getActionRowActivatableWidget           ,
    setActionRowActivatableWidget           ,


-- ** iconName #attr:iconName#
{- | The icon name for this row.

/Since: 0.0.6/
-}
#if ENABLE_OVERLOADING
    ActionRowIconNamePropertyInfo           ,
#endif
#if ENABLE_OVERLOADING
    actionRowIconName                       ,
#endif
    constructActionRowIconName              ,
    getActionRowIconName                    ,
    setActionRowIconName                    ,


-- ** subtitle #attr:subtitle#
{- | The subtitle for this row.

/Since: 0.0.6/
-}
#if ENABLE_OVERLOADING
    ActionRowSubtitlePropertyInfo           ,
#endif
#if ENABLE_OVERLOADING
    actionRowSubtitle                       ,
#endif
    constructActionRowSubtitle              ,
    getActionRowSubtitle                    ,
    setActionRowSubtitle                    ,


-- ** title #attr:title#
{- | The title for this row.

/Since: 0.0.6/
-}
#if ENABLE_OVERLOADING
    ActionRowTitlePropertyInfo              ,
#endif
#if ENABLE_OVERLOADING
    actionRowTitle                          ,
#endif
    constructActionRowTitle                 ,
    getActionRowTitle                       ,
    setActionRowTitle                       ,


-- ** useUnderline #attr:useUnderline#
{- | Whether an embedded underline in the text of the title and subtitle labels
indicates a mnemonic.

/Since: 0.0.6/
-}
#if ENABLE_OVERLOADING
    ActionRowUseUnderlinePropertyInfo       ,
#endif
#if ENABLE_OVERLOADING
    actionRowUseUnderline                   ,
#endif
    constructActionRowUseUnderline          ,
    getActionRowUseUnderline                ,
    setActionRowUseUnderline                ,




    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL

import qualified GI.Atk.Interfaces.ImplementorIface as Atk.ImplementorIface
import qualified GI.GObject.Objects.Object as GObject.Object
import qualified GI.Gtk.Interfaces.Actionable as Gtk.Actionable
import qualified GI.Gtk.Interfaces.Buildable as Gtk.Buildable
import qualified GI.Gtk.Objects.Bin as Gtk.Bin
import qualified GI.Gtk.Objects.Container as Gtk.Container
import qualified GI.Gtk.Objects.ListBoxRow as Gtk.ListBoxRow
import qualified GI.Gtk.Objects.Widget as Gtk.Widget

-- | Memory-managed wrapper type.
newtype ActionRow = ActionRow (ManagedPtr ActionRow)
foreign import ccall "hdy_action_row_get_type"
    c_hdy_action_row_get_type :: IO GType

instance GObject ActionRow where
    gobjectType = c_hdy_action_row_get_type
    

-- | Type class for types which can be safely cast to `ActionRow`, for instance with `toActionRow`.
class (GObject o, O.IsDescendantOf ActionRow o) => IsActionRow o
instance (GObject o, O.IsDescendantOf ActionRow o) => IsActionRow o

instance O.HasParentTypes ActionRow
type instance O.ParentTypes ActionRow = '[Gtk.ListBoxRow.ListBoxRow, Gtk.Bin.Bin, Gtk.Container.Container, Gtk.Widget.Widget, GObject.Object.Object, Atk.ImplementorIface.ImplementorIface, Gtk.Actionable.Actionable, Gtk.Buildable.Buildable]

-- | Cast to `ActionRow`, for types for which this is known to be safe. For general casts, use `Data.GI.Base.ManagedPtr.castTo`.
toActionRow :: (MonadIO m, IsActionRow o) => o -> m ActionRow
toActionRow = liftIO . unsafeCastTo ActionRow

-- | A convenience alias for `Nothing` :: `Maybe` `ActionRow`.
noActionRow :: Maybe ActionRow
noActionRow = Nothing

#if ENABLE_OVERLOADING
type family ResolveActionRowMethod (t :: Symbol) (o :: *) :: * where
    ResolveActionRowMethod "activate" o = ActionRowActivateMethodInfo
    ResolveActionRowMethod "add" o = Gtk.Container.ContainerAddMethodInfo
    ResolveActionRowMethod "addAccelerator" o = Gtk.Widget.WidgetAddAcceleratorMethodInfo
    ResolveActionRowMethod "addAction" o = ActionRowAddActionMethodInfo
    ResolveActionRowMethod "addChild" o = Gtk.Buildable.BuildableAddChildMethodInfo
    ResolveActionRowMethod "addDeviceEvents" o = Gtk.Widget.WidgetAddDeviceEventsMethodInfo
    ResolveActionRowMethod "addEvents" o = Gtk.Widget.WidgetAddEventsMethodInfo
    ResolveActionRowMethod "addMnemonicLabel" o = Gtk.Widget.WidgetAddMnemonicLabelMethodInfo
    ResolveActionRowMethod "addPrefix" o = ActionRowAddPrefixMethodInfo
    ResolveActionRowMethod "addTickCallback" o = Gtk.Widget.WidgetAddTickCallbackMethodInfo
    ResolveActionRowMethod "bindProperty" o = GObject.Object.ObjectBindPropertyMethodInfo
    ResolveActionRowMethod "bindPropertyFull" o = GObject.Object.ObjectBindPropertyFullMethodInfo
    ResolveActionRowMethod "canActivateAccel" o = Gtk.Widget.WidgetCanActivateAccelMethodInfo
    ResolveActionRowMethod "changed" o = Gtk.ListBoxRow.ListBoxRowChangedMethodInfo
    ResolveActionRowMethod "checkResize" o = Gtk.Container.ContainerCheckResizeMethodInfo
    ResolveActionRowMethod "childFocus" o = Gtk.Widget.WidgetChildFocusMethodInfo
    ResolveActionRowMethod "childGetProperty" o = Gtk.Container.ContainerChildGetPropertyMethodInfo
    ResolveActionRowMethod "childNotify" o = Gtk.Container.ContainerChildNotifyMethodInfo
    ResolveActionRowMethod "childNotifyByPspec" o = Gtk.Container.ContainerChildNotifyByPspecMethodInfo
    ResolveActionRowMethod "childSetProperty" o = Gtk.Container.ContainerChildSetPropertyMethodInfo
    ResolveActionRowMethod "childType" o = Gtk.Container.ContainerChildTypeMethodInfo
    ResolveActionRowMethod "classPath" o = Gtk.Widget.WidgetClassPathMethodInfo
    ResolveActionRowMethod "computeExpand" o = Gtk.Widget.WidgetComputeExpandMethodInfo
    ResolveActionRowMethod "constructChild" o = Gtk.Buildable.BuildableConstructChildMethodInfo
    ResolveActionRowMethod "createPangoContext" o = Gtk.Widget.WidgetCreatePangoContextMethodInfo
    ResolveActionRowMethod "createPangoLayout" o = Gtk.Widget.WidgetCreatePangoLayoutMethodInfo
    ResolveActionRowMethod "customFinished" o = Gtk.Buildable.BuildableCustomFinishedMethodInfo
    ResolveActionRowMethod "customTagEnd" o = Gtk.Buildable.BuildableCustomTagEndMethodInfo
    ResolveActionRowMethod "customTagStart" o = Gtk.Buildable.BuildableCustomTagStartMethodInfo
    ResolveActionRowMethod "destroy" o = Gtk.Widget.WidgetDestroyMethodInfo
    ResolveActionRowMethod "destroyed" o = Gtk.Widget.WidgetDestroyedMethodInfo
    ResolveActionRowMethod "deviceIsShadowed" o = Gtk.Widget.WidgetDeviceIsShadowedMethodInfo
    ResolveActionRowMethod "dragBegin" o = Gtk.Widget.WidgetDragBeginMethodInfo
    ResolveActionRowMethod "dragBeginWithCoordinates" o = Gtk.Widget.WidgetDragBeginWithCoordinatesMethodInfo
    ResolveActionRowMethod "dragCheckThreshold" o = Gtk.Widget.WidgetDragCheckThresholdMethodInfo
    ResolveActionRowMethod "dragDestAddImageTargets" o = Gtk.Widget.WidgetDragDestAddImageTargetsMethodInfo
    ResolveActionRowMethod "dragDestAddTextTargets" o = Gtk.Widget.WidgetDragDestAddTextTargetsMethodInfo
    ResolveActionRowMethod "dragDestAddUriTargets" o = Gtk.Widget.WidgetDragDestAddUriTargetsMethodInfo
    ResolveActionRowMethod "dragDestFindTarget" o = Gtk.Widget.WidgetDragDestFindTargetMethodInfo
    ResolveActionRowMethod "dragDestGetTargetList" o = Gtk.Widget.WidgetDragDestGetTargetListMethodInfo
    ResolveActionRowMethod "dragDestGetTrackMotion" o = Gtk.Widget.WidgetDragDestGetTrackMotionMethodInfo
    ResolveActionRowMethod "dragDestSet" o = Gtk.Widget.WidgetDragDestSetMethodInfo
    ResolveActionRowMethod "dragDestSetProxy" o = Gtk.Widget.WidgetDragDestSetProxyMethodInfo
    ResolveActionRowMethod "dragDestSetTargetList" o = Gtk.Widget.WidgetDragDestSetTargetListMethodInfo
    ResolveActionRowMethod "dragDestSetTrackMotion" o = Gtk.Widget.WidgetDragDestSetTrackMotionMethodInfo
    ResolveActionRowMethod "dragDestUnset" o = Gtk.Widget.WidgetDragDestUnsetMethodInfo
    ResolveActionRowMethod "dragGetData" o = Gtk.Widget.WidgetDragGetDataMethodInfo
    ResolveActionRowMethod "dragHighlight" o = Gtk.Widget.WidgetDragHighlightMethodInfo
    ResolveActionRowMethod "dragSourceAddImageTargets" o = Gtk.Widget.WidgetDragSourceAddImageTargetsMethodInfo
    ResolveActionRowMethod "dragSourceAddTextTargets" o = Gtk.Widget.WidgetDragSourceAddTextTargetsMethodInfo
    ResolveActionRowMethod "dragSourceAddUriTargets" o = Gtk.Widget.WidgetDragSourceAddUriTargetsMethodInfo
    ResolveActionRowMethod "dragSourceGetTargetList" o = Gtk.Widget.WidgetDragSourceGetTargetListMethodInfo
    ResolveActionRowMethod "dragSourceSet" o = Gtk.Widget.WidgetDragSourceSetMethodInfo
    ResolveActionRowMethod "dragSourceSetIconGicon" o = Gtk.Widget.WidgetDragSourceSetIconGiconMethodInfo
    ResolveActionRowMethod "dragSourceSetIconName" o = Gtk.Widget.WidgetDragSourceSetIconNameMethodInfo
    ResolveActionRowMethod "dragSourceSetIconPixbuf" o = Gtk.Widget.WidgetDragSourceSetIconPixbufMethodInfo
    ResolveActionRowMethod "dragSourceSetIconStock" o = Gtk.Widget.WidgetDragSourceSetIconStockMethodInfo
    ResolveActionRowMethod "dragSourceSetTargetList" o = Gtk.Widget.WidgetDragSourceSetTargetListMethodInfo
    ResolveActionRowMethod "dragSourceUnset" o = Gtk.Widget.WidgetDragSourceUnsetMethodInfo
    ResolveActionRowMethod "dragUnhighlight" o = Gtk.Widget.WidgetDragUnhighlightMethodInfo
    ResolveActionRowMethod "draw" o = Gtk.Widget.WidgetDrawMethodInfo
    ResolveActionRowMethod "ensureStyle" o = Gtk.Widget.WidgetEnsureStyleMethodInfo
    ResolveActionRowMethod "errorBell" o = Gtk.Widget.WidgetErrorBellMethodInfo
    ResolveActionRowMethod "event" o = Gtk.Widget.WidgetEventMethodInfo
    ResolveActionRowMethod "forall" o = Gtk.Container.ContainerForallMethodInfo
    ResolveActionRowMethod "forceFloating" o = GObject.Object.ObjectForceFloatingMethodInfo
    ResolveActionRowMethod "foreach" o = Gtk.Container.ContainerForeachMethodInfo
    ResolveActionRowMethod "freezeChildNotify" o = Gtk.Widget.WidgetFreezeChildNotifyMethodInfo
    ResolveActionRowMethod "freezeNotify" o = GObject.Object.ObjectFreezeNotifyMethodInfo
    ResolveActionRowMethod "getv" o = GObject.Object.ObjectGetvMethodInfo
    ResolveActionRowMethod "grabAdd" o = Gtk.Widget.WidgetGrabAddMethodInfo
    ResolveActionRowMethod "grabDefault" o = Gtk.Widget.WidgetGrabDefaultMethodInfo
    ResolveActionRowMethod "grabFocus" o = Gtk.Widget.WidgetGrabFocusMethodInfo
    ResolveActionRowMethod "grabRemove" o = Gtk.Widget.WidgetGrabRemoveMethodInfo
    ResolveActionRowMethod "hasDefault" o = Gtk.Widget.WidgetHasDefaultMethodInfo
    ResolveActionRowMethod "hasFocus" o = Gtk.Widget.WidgetHasFocusMethodInfo
    ResolveActionRowMethod "hasGrab" o = Gtk.Widget.WidgetHasGrabMethodInfo
    ResolveActionRowMethod "hasRcStyle" o = Gtk.Widget.WidgetHasRcStyleMethodInfo
    ResolveActionRowMethod "hasScreen" o = Gtk.Widget.WidgetHasScreenMethodInfo
    ResolveActionRowMethod "hasVisibleFocus" o = Gtk.Widget.WidgetHasVisibleFocusMethodInfo
    ResolveActionRowMethod "hide" o = Gtk.Widget.WidgetHideMethodInfo
    ResolveActionRowMethod "hideOnDelete" o = Gtk.Widget.WidgetHideOnDeleteMethodInfo
    ResolveActionRowMethod "inDestruction" o = Gtk.Widget.WidgetInDestructionMethodInfo
    ResolveActionRowMethod "initTemplate" o = Gtk.Widget.WidgetInitTemplateMethodInfo
    ResolveActionRowMethod "inputShapeCombineRegion" o = Gtk.Widget.WidgetInputShapeCombineRegionMethodInfo
    ResolveActionRowMethod "insertActionGroup" o = Gtk.Widget.WidgetInsertActionGroupMethodInfo
    ResolveActionRowMethod "intersect" o = Gtk.Widget.WidgetIntersectMethodInfo
    ResolveActionRowMethod "isAncestor" o = Gtk.Widget.WidgetIsAncestorMethodInfo
    ResolveActionRowMethod "isComposited" o = Gtk.Widget.WidgetIsCompositedMethodInfo
    ResolveActionRowMethod "isDrawable" o = Gtk.Widget.WidgetIsDrawableMethodInfo
    ResolveActionRowMethod "isFloating" o = GObject.Object.ObjectIsFloatingMethodInfo
    ResolveActionRowMethod "isFocus" o = Gtk.Widget.WidgetIsFocusMethodInfo
    ResolveActionRowMethod "isSelected" o = Gtk.ListBoxRow.ListBoxRowIsSelectedMethodInfo
    ResolveActionRowMethod "isSensitive" o = Gtk.Widget.WidgetIsSensitiveMethodInfo
    ResolveActionRowMethod "isToplevel" o = Gtk.Widget.WidgetIsToplevelMethodInfo
    ResolveActionRowMethod "isVisible" o = Gtk.Widget.WidgetIsVisibleMethodInfo
    ResolveActionRowMethod "keynavFailed" o = Gtk.Widget.WidgetKeynavFailedMethodInfo
    ResolveActionRowMethod "listAccelClosures" o = Gtk.Widget.WidgetListAccelClosuresMethodInfo
    ResolveActionRowMethod "listActionPrefixes" o = Gtk.Widget.WidgetListActionPrefixesMethodInfo
    ResolveActionRowMethod "listMnemonicLabels" o = Gtk.Widget.WidgetListMnemonicLabelsMethodInfo
    ResolveActionRowMethod "map" o = Gtk.Widget.WidgetMapMethodInfo
    ResolveActionRowMethod "mnemonicActivate" o = Gtk.Widget.WidgetMnemonicActivateMethodInfo
    ResolveActionRowMethod "modifyBase" o = Gtk.Widget.WidgetModifyBaseMethodInfo
    ResolveActionRowMethod "modifyBg" o = Gtk.Widget.WidgetModifyBgMethodInfo
    ResolveActionRowMethod "modifyCursor" o = Gtk.Widget.WidgetModifyCursorMethodInfo
    ResolveActionRowMethod "modifyFg" o = Gtk.Widget.WidgetModifyFgMethodInfo
    ResolveActionRowMethod "modifyFont" o = Gtk.Widget.WidgetModifyFontMethodInfo
    ResolveActionRowMethod "modifyStyle" o = Gtk.Widget.WidgetModifyStyleMethodInfo
    ResolveActionRowMethod "modifyText" o = Gtk.Widget.WidgetModifyTextMethodInfo
    ResolveActionRowMethod "notify" o = GObject.Object.ObjectNotifyMethodInfo
    ResolveActionRowMethod "notifyByPspec" o = GObject.Object.ObjectNotifyByPspecMethodInfo
    ResolveActionRowMethod "overrideBackgroundColor" o = Gtk.Widget.WidgetOverrideBackgroundColorMethodInfo
    ResolveActionRowMethod "overrideColor" o = Gtk.Widget.WidgetOverrideColorMethodInfo
    ResolveActionRowMethod "overrideCursor" o = Gtk.Widget.WidgetOverrideCursorMethodInfo
    ResolveActionRowMethod "overrideFont" o = Gtk.Widget.WidgetOverrideFontMethodInfo
    ResolveActionRowMethod "overrideSymbolicColor" o = Gtk.Widget.WidgetOverrideSymbolicColorMethodInfo
    ResolveActionRowMethod "parserFinished" o = Gtk.Buildable.BuildableParserFinishedMethodInfo
    ResolveActionRowMethod "path" o = Gtk.Widget.WidgetPathMethodInfo
    ResolveActionRowMethod "propagateDraw" o = Gtk.Container.ContainerPropagateDrawMethodInfo
    ResolveActionRowMethod "queueAllocate" o = Gtk.Widget.WidgetQueueAllocateMethodInfo
    ResolveActionRowMethod "queueComputeExpand" o = Gtk.Widget.WidgetQueueComputeExpandMethodInfo
    ResolveActionRowMethod "queueDraw" o = Gtk.Widget.WidgetQueueDrawMethodInfo
    ResolveActionRowMethod "queueDrawArea" o = Gtk.Widget.WidgetQueueDrawAreaMethodInfo
    ResolveActionRowMethod "queueDrawRegion" o = Gtk.Widget.WidgetQueueDrawRegionMethodInfo
    ResolveActionRowMethod "queueResize" o = Gtk.Widget.WidgetQueueResizeMethodInfo
    ResolveActionRowMethod "queueResizeNoRedraw" o = Gtk.Widget.WidgetQueueResizeNoRedrawMethodInfo
    ResolveActionRowMethod "realize" o = Gtk.Widget.WidgetRealizeMethodInfo
    ResolveActionRowMethod "ref" o = GObject.Object.ObjectRefMethodInfo
    ResolveActionRowMethod "refSink" o = GObject.Object.ObjectRefSinkMethodInfo
    ResolveActionRowMethod "regionIntersect" o = Gtk.Widget.WidgetRegionIntersectMethodInfo
    ResolveActionRowMethod "registerWindow" o = Gtk.Widget.WidgetRegisterWindowMethodInfo
    ResolveActionRowMethod "remove" o = Gtk.Container.ContainerRemoveMethodInfo
    ResolveActionRowMethod "removeAccelerator" o = Gtk.Widget.WidgetRemoveAcceleratorMethodInfo
    ResolveActionRowMethod "removeMnemonicLabel" o = Gtk.Widget.WidgetRemoveMnemonicLabelMethodInfo
    ResolveActionRowMethod "removeTickCallback" o = Gtk.Widget.WidgetRemoveTickCallbackMethodInfo
    ResolveActionRowMethod "renderIcon" o = Gtk.Widget.WidgetRenderIconMethodInfo
    ResolveActionRowMethod "renderIconPixbuf" o = Gtk.Widget.WidgetRenderIconPixbufMethodInfo
    ResolveActionRowMethod "reparent" o = Gtk.Widget.WidgetReparentMethodInfo
    ResolveActionRowMethod "resetRcStyles" o = Gtk.Widget.WidgetResetRcStylesMethodInfo
    ResolveActionRowMethod "resetStyle" o = Gtk.Widget.WidgetResetStyleMethodInfo
    ResolveActionRowMethod "resizeChildren" o = Gtk.Container.ContainerResizeChildrenMethodInfo
    ResolveActionRowMethod "runDispose" o = GObject.Object.ObjectRunDisposeMethodInfo
    ResolveActionRowMethod "sendExpose" o = Gtk.Widget.WidgetSendExposeMethodInfo
    ResolveActionRowMethod "sendFocusChange" o = Gtk.Widget.WidgetSendFocusChangeMethodInfo
    ResolveActionRowMethod "shapeCombineRegion" o = Gtk.Widget.WidgetShapeCombineRegionMethodInfo
    ResolveActionRowMethod "show" o = Gtk.Widget.WidgetShowMethodInfo
    ResolveActionRowMethod "showAll" o = Gtk.Widget.WidgetShowAllMethodInfo
    ResolveActionRowMethod "showNow" o = Gtk.Widget.WidgetShowNowMethodInfo
    ResolveActionRowMethod "sizeAllocate" o = Gtk.Widget.WidgetSizeAllocateMethodInfo
    ResolveActionRowMethod "sizeAllocateWithBaseline" o = Gtk.Widget.WidgetSizeAllocateWithBaselineMethodInfo
    ResolveActionRowMethod "sizeRequest" o = Gtk.Widget.WidgetSizeRequestMethodInfo
    ResolveActionRowMethod "stealData" o = GObject.Object.ObjectStealDataMethodInfo
    ResolveActionRowMethod "stealQdata" o = GObject.Object.ObjectStealQdataMethodInfo
    ResolveActionRowMethod "styleAttach" o = Gtk.Widget.WidgetStyleAttachMethodInfo
    ResolveActionRowMethod "styleGetProperty" o = Gtk.Widget.WidgetStyleGetPropertyMethodInfo
    ResolveActionRowMethod "thawChildNotify" o = Gtk.Widget.WidgetThawChildNotifyMethodInfo
    ResolveActionRowMethod "thawNotify" o = GObject.Object.ObjectThawNotifyMethodInfo
    ResolveActionRowMethod "translateCoordinates" o = Gtk.Widget.WidgetTranslateCoordinatesMethodInfo
    ResolveActionRowMethod "triggerTooltipQuery" o = Gtk.Widget.WidgetTriggerTooltipQueryMethodInfo
    ResolveActionRowMethod "unmap" o = Gtk.Widget.WidgetUnmapMethodInfo
    ResolveActionRowMethod "unparent" o = Gtk.Widget.WidgetUnparentMethodInfo
    ResolveActionRowMethod "unrealize" o = Gtk.Widget.WidgetUnrealizeMethodInfo
    ResolveActionRowMethod "unref" o = GObject.Object.ObjectUnrefMethodInfo
    ResolveActionRowMethod "unregisterWindow" o = Gtk.Widget.WidgetUnregisterWindowMethodInfo
    ResolveActionRowMethod "unsetFocusChain" o = Gtk.Container.ContainerUnsetFocusChainMethodInfo
    ResolveActionRowMethod "unsetStateFlags" o = Gtk.Widget.WidgetUnsetStateFlagsMethodInfo
    ResolveActionRowMethod "watchClosure" o = GObject.Object.ObjectWatchClosureMethodInfo
    ResolveActionRowMethod "getAccessible" o = Gtk.Widget.WidgetGetAccessibleMethodInfo
    ResolveActionRowMethod "getActionGroup" o = Gtk.Widget.WidgetGetActionGroupMethodInfo
    ResolveActionRowMethod "getActionName" o = Gtk.Actionable.ActionableGetActionNameMethodInfo
    ResolveActionRowMethod "getActionTargetValue" o = Gtk.Actionable.ActionableGetActionTargetValueMethodInfo
    ResolveActionRowMethod "getActivatable" o = Gtk.ListBoxRow.ListBoxRowGetActivatableMethodInfo
    ResolveActionRowMethod "getActivatableWidget" o = ActionRowGetActivatableWidgetMethodInfo
    ResolveActionRowMethod "getAllocatedBaseline" o = Gtk.Widget.WidgetGetAllocatedBaselineMethodInfo
    ResolveActionRowMethod "getAllocatedHeight" o = Gtk.Widget.WidgetGetAllocatedHeightMethodInfo
    ResolveActionRowMethod "getAllocatedSize" o = Gtk.Widget.WidgetGetAllocatedSizeMethodInfo
    ResolveActionRowMethod "getAllocatedWidth" o = Gtk.Widget.WidgetGetAllocatedWidthMethodInfo
    ResolveActionRowMethod "getAllocation" o = Gtk.Widget.WidgetGetAllocationMethodInfo
    ResolveActionRowMethod "getAncestor" o = Gtk.Widget.WidgetGetAncestorMethodInfo
    ResolveActionRowMethod "getAppPaintable" o = Gtk.Widget.WidgetGetAppPaintableMethodInfo
    ResolveActionRowMethod "getBorderWidth" o = Gtk.Container.ContainerGetBorderWidthMethodInfo
    ResolveActionRowMethod "getCanDefault" o = Gtk.Widget.WidgetGetCanDefaultMethodInfo
    ResolveActionRowMethod "getCanFocus" o = Gtk.Widget.WidgetGetCanFocusMethodInfo
    ResolveActionRowMethod "getChild" o = Gtk.Bin.BinGetChildMethodInfo
    ResolveActionRowMethod "getChildRequisition" o = Gtk.Widget.WidgetGetChildRequisitionMethodInfo
    ResolveActionRowMethod "getChildVisible" o = Gtk.Widget.WidgetGetChildVisibleMethodInfo
    ResolveActionRowMethod "getChildren" o = Gtk.Container.ContainerGetChildrenMethodInfo
    ResolveActionRowMethod "getClip" o = Gtk.Widget.WidgetGetClipMethodInfo
    ResolveActionRowMethod "getClipboard" o = Gtk.Widget.WidgetGetClipboardMethodInfo
    ResolveActionRowMethod "getCompositeName" o = Gtk.Widget.WidgetGetCompositeNameMethodInfo
    ResolveActionRowMethod "getData" o = GObject.Object.ObjectGetDataMethodInfo
    ResolveActionRowMethod "getDeviceEnabled" o = Gtk.Widget.WidgetGetDeviceEnabledMethodInfo
    ResolveActionRowMethod "getDeviceEvents" o = Gtk.Widget.WidgetGetDeviceEventsMethodInfo
    ResolveActionRowMethod "getDirection" o = Gtk.Widget.WidgetGetDirectionMethodInfo
    ResolveActionRowMethod "getDisplay" o = Gtk.Widget.WidgetGetDisplayMethodInfo
    ResolveActionRowMethod "getDoubleBuffered" o = Gtk.Widget.WidgetGetDoubleBufferedMethodInfo
    ResolveActionRowMethod "getEvents" o = Gtk.Widget.WidgetGetEventsMethodInfo
    ResolveActionRowMethod "getFocusChain" o = Gtk.Container.ContainerGetFocusChainMethodInfo
    ResolveActionRowMethod "getFocusChild" o = Gtk.Container.ContainerGetFocusChildMethodInfo
    ResolveActionRowMethod "getFocusHadjustment" o = Gtk.Container.ContainerGetFocusHadjustmentMethodInfo
    ResolveActionRowMethod "getFocusOnClick" o = Gtk.Widget.WidgetGetFocusOnClickMethodInfo
    ResolveActionRowMethod "getFocusVadjustment" o = Gtk.Container.ContainerGetFocusVadjustmentMethodInfo
    ResolveActionRowMethod "getFontMap" o = Gtk.Widget.WidgetGetFontMapMethodInfo
    ResolveActionRowMethod "getFontOptions" o = Gtk.Widget.WidgetGetFontOptionsMethodInfo
    ResolveActionRowMethod "getFrameClock" o = Gtk.Widget.WidgetGetFrameClockMethodInfo
    ResolveActionRowMethod "getHalign" o = Gtk.Widget.WidgetGetHalignMethodInfo
    ResolveActionRowMethod "getHasTooltip" o = Gtk.Widget.WidgetGetHasTooltipMethodInfo
    ResolveActionRowMethod "getHasWindow" o = Gtk.Widget.WidgetGetHasWindowMethodInfo
    ResolveActionRowMethod "getHeader" o = Gtk.ListBoxRow.ListBoxRowGetHeaderMethodInfo
    ResolveActionRowMethod "getHexpand" o = Gtk.Widget.WidgetGetHexpandMethodInfo
    ResolveActionRowMethod "getHexpandSet" o = Gtk.Widget.WidgetGetHexpandSetMethodInfo
    ResolveActionRowMethod "getIconName" o = ActionRowGetIconNameMethodInfo
    ResolveActionRowMethod "getIndex" o = Gtk.ListBoxRow.ListBoxRowGetIndexMethodInfo
    ResolveActionRowMethod "getInternalChild" o = Gtk.Buildable.BuildableGetInternalChildMethodInfo
    ResolveActionRowMethod "getMapped" o = Gtk.Widget.WidgetGetMappedMethodInfo
    ResolveActionRowMethod "getMarginBottom" o = Gtk.Widget.WidgetGetMarginBottomMethodInfo
    ResolveActionRowMethod "getMarginEnd" o = Gtk.Widget.WidgetGetMarginEndMethodInfo
    ResolveActionRowMethod "getMarginLeft" o = Gtk.Widget.WidgetGetMarginLeftMethodInfo
    ResolveActionRowMethod "getMarginRight" o = Gtk.Widget.WidgetGetMarginRightMethodInfo
    ResolveActionRowMethod "getMarginStart" o = Gtk.Widget.WidgetGetMarginStartMethodInfo
    ResolveActionRowMethod "getMarginTop" o = Gtk.Widget.WidgetGetMarginTopMethodInfo
    ResolveActionRowMethod "getModifierMask" o = Gtk.Widget.WidgetGetModifierMaskMethodInfo
    ResolveActionRowMethod "getModifierStyle" o = Gtk.Widget.WidgetGetModifierStyleMethodInfo
    ResolveActionRowMethod "getName" o = Gtk.Widget.WidgetGetNameMethodInfo
    ResolveActionRowMethod "getNoShowAll" o = Gtk.Widget.WidgetGetNoShowAllMethodInfo
    ResolveActionRowMethod "getOpacity" o = Gtk.Widget.WidgetGetOpacityMethodInfo
    ResolveActionRowMethod "getPangoContext" o = Gtk.Widget.WidgetGetPangoContextMethodInfo
    ResolveActionRowMethod "getParent" o = Gtk.Widget.WidgetGetParentMethodInfo
    ResolveActionRowMethod "getParentWindow" o = Gtk.Widget.WidgetGetParentWindowMethodInfo
    ResolveActionRowMethod "getPath" o = Gtk.Widget.WidgetGetPathMethodInfo
    ResolveActionRowMethod "getPathForChild" o = Gtk.Container.ContainerGetPathForChildMethodInfo
    ResolveActionRowMethod "getPointer" o = Gtk.Widget.WidgetGetPointerMethodInfo
    ResolveActionRowMethod "getPreferredHeight" o = Gtk.Widget.WidgetGetPreferredHeightMethodInfo
    ResolveActionRowMethod "getPreferredHeightAndBaselineForWidth" o = Gtk.Widget.WidgetGetPreferredHeightAndBaselineForWidthMethodInfo
    ResolveActionRowMethod "getPreferredHeightForWidth" o = Gtk.Widget.WidgetGetPreferredHeightForWidthMethodInfo
    ResolveActionRowMethod "getPreferredSize" o = Gtk.Widget.WidgetGetPreferredSizeMethodInfo
    ResolveActionRowMethod "getPreferredWidth" o = Gtk.Widget.WidgetGetPreferredWidthMethodInfo
    ResolveActionRowMethod "getPreferredWidthForHeight" o = Gtk.Widget.WidgetGetPreferredWidthForHeightMethodInfo
    ResolveActionRowMethod "getProperty" o = GObject.Object.ObjectGetPropertyMethodInfo
    ResolveActionRowMethod "getQdata" o = GObject.Object.ObjectGetQdataMethodInfo
    ResolveActionRowMethod "getRealized" o = Gtk.Widget.WidgetGetRealizedMethodInfo
    ResolveActionRowMethod "getReceivesDefault" o = Gtk.Widget.WidgetGetReceivesDefaultMethodInfo
    ResolveActionRowMethod "getRequestMode" o = Gtk.Widget.WidgetGetRequestModeMethodInfo
    ResolveActionRowMethod "getRequisition" o = Gtk.Widget.WidgetGetRequisitionMethodInfo
    ResolveActionRowMethod "getResizeMode" o = Gtk.Container.ContainerGetResizeModeMethodInfo
    ResolveActionRowMethod "getRootWindow" o = Gtk.Widget.WidgetGetRootWindowMethodInfo
    ResolveActionRowMethod "getScaleFactor" o = Gtk.Widget.WidgetGetScaleFactorMethodInfo
    ResolveActionRowMethod "getScreen" o = Gtk.Widget.WidgetGetScreenMethodInfo
    ResolveActionRowMethod "getSelectable" o = Gtk.ListBoxRow.ListBoxRowGetSelectableMethodInfo
    ResolveActionRowMethod "getSensitive" o = Gtk.Widget.WidgetGetSensitiveMethodInfo
    ResolveActionRowMethod "getSettings" o = Gtk.Widget.WidgetGetSettingsMethodInfo
    ResolveActionRowMethod "getSizeRequest" o = Gtk.Widget.WidgetGetSizeRequestMethodInfo
    ResolveActionRowMethod "getState" o = Gtk.Widget.WidgetGetStateMethodInfo
    ResolveActionRowMethod "getStateFlags" o = Gtk.Widget.WidgetGetStateFlagsMethodInfo
    ResolveActionRowMethod "getStyle" o = Gtk.Widget.WidgetGetStyleMethodInfo
    ResolveActionRowMethod "getStyleContext" o = Gtk.Widget.WidgetGetStyleContextMethodInfo
    ResolveActionRowMethod "getSubtitle" o = ActionRowGetSubtitleMethodInfo
    ResolveActionRowMethod "getSupportMultidevice" o = Gtk.Widget.WidgetGetSupportMultideviceMethodInfo
    ResolveActionRowMethod "getTemplateChild" o = Gtk.Widget.WidgetGetTemplateChildMethodInfo
    ResolveActionRowMethod "getTitle" o = ActionRowGetTitleMethodInfo
    ResolveActionRowMethod "getTooltipMarkup" o = Gtk.Widget.WidgetGetTooltipMarkupMethodInfo
    ResolveActionRowMethod "getTooltipText" o = Gtk.Widget.WidgetGetTooltipTextMethodInfo
    ResolveActionRowMethod "getTooltipWindow" o = Gtk.Widget.WidgetGetTooltipWindowMethodInfo
    ResolveActionRowMethod "getToplevel" o = Gtk.Widget.WidgetGetToplevelMethodInfo
    ResolveActionRowMethod "getUseUnderline" o = ActionRowGetUseUnderlineMethodInfo
    ResolveActionRowMethod "getValign" o = Gtk.Widget.WidgetGetValignMethodInfo
    ResolveActionRowMethod "getValignWithBaseline" o = Gtk.Widget.WidgetGetValignWithBaselineMethodInfo
    ResolveActionRowMethod "getVexpand" o = Gtk.Widget.WidgetGetVexpandMethodInfo
    ResolveActionRowMethod "getVexpandSet" o = Gtk.Widget.WidgetGetVexpandSetMethodInfo
    ResolveActionRowMethod "getVisible" o = Gtk.Widget.WidgetGetVisibleMethodInfo
    ResolveActionRowMethod "getVisual" o = Gtk.Widget.WidgetGetVisualMethodInfo
    ResolveActionRowMethod "getWindow" o = Gtk.Widget.WidgetGetWindowMethodInfo
    ResolveActionRowMethod "setAccelPath" o = Gtk.Widget.WidgetSetAccelPathMethodInfo
    ResolveActionRowMethod "setActionName" o = Gtk.Actionable.ActionableSetActionNameMethodInfo
    ResolveActionRowMethod "setActionTargetValue" o = Gtk.Actionable.ActionableSetActionTargetValueMethodInfo
    ResolveActionRowMethod "setActivatable" o = Gtk.ListBoxRow.ListBoxRowSetActivatableMethodInfo
    ResolveActionRowMethod "setActivatableWidget" o = ActionRowSetActivatableWidgetMethodInfo
    ResolveActionRowMethod "setAllocation" o = Gtk.Widget.WidgetSetAllocationMethodInfo
    ResolveActionRowMethod "setAppPaintable" o = Gtk.Widget.WidgetSetAppPaintableMethodInfo
    ResolveActionRowMethod "setBorderWidth" o = Gtk.Container.ContainerSetBorderWidthMethodInfo
    ResolveActionRowMethod "setBuildableProperty" o = Gtk.Buildable.BuildableSetBuildablePropertyMethodInfo
    ResolveActionRowMethod "setCanDefault" o = Gtk.Widget.WidgetSetCanDefaultMethodInfo
    ResolveActionRowMethod "setCanFocus" o = Gtk.Widget.WidgetSetCanFocusMethodInfo
    ResolveActionRowMethod "setChildVisible" o = Gtk.Widget.WidgetSetChildVisibleMethodInfo
    ResolveActionRowMethod "setClip" o = Gtk.Widget.WidgetSetClipMethodInfo
    ResolveActionRowMethod "setCompositeName" o = Gtk.Widget.WidgetSetCompositeNameMethodInfo
    ResolveActionRowMethod "setData" o = GObject.Object.ObjectSetDataMethodInfo
    ResolveActionRowMethod "setDetailedActionName" o = Gtk.Actionable.ActionableSetDetailedActionNameMethodInfo
    ResolveActionRowMethod "setDeviceEnabled" o = Gtk.Widget.WidgetSetDeviceEnabledMethodInfo
    ResolveActionRowMethod "setDeviceEvents" o = Gtk.Widget.WidgetSetDeviceEventsMethodInfo
    ResolveActionRowMethod "setDirection" o = Gtk.Widget.WidgetSetDirectionMethodInfo
    ResolveActionRowMethod "setDoubleBuffered" o = Gtk.Widget.WidgetSetDoubleBufferedMethodInfo
    ResolveActionRowMethod "setEvents" o = Gtk.Widget.WidgetSetEventsMethodInfo
    ResolveActionRowMethod "setFocusChain" o = Gtk.Container.ContainerSetFocusChainMethodInfo
    ResolveActionRowMethod "setFocusChild" o = Gtk.Container.ContainerSetFocusChildMethodInfo
    ResolveActionRowMethod "setFocusHadjustment" o = Gtk.Container.ContainerSetFocusHadjustmentMethodInfo
    ResolveActionRowMethod "setFocusOnClick" o = Gtk.Widget.WidgetSetFocusOnClickMethodInfo
    ResolveActionRowMethod "setFocusVadjustment" o = Gtk.Container.ContainerSetFocusVadjustmentMethodInfo
    ResolveActionRowMethod "setFontMap" o = Gtk.Widget.WidgetSetFontMapMethodInfo
    ResolveActionRowMethod "setFontOptions" o = Gtk.Widget.WidgetSetFontOptionsMethodInfo
    ResolveActionRowMethod "setHalign" o = Gtk.Widget.WidgetSetHalignMethodInfo
    ResolveActionRowMethod "setHasTooltip" o = Gtk.Widget.WidgetSetHasTooltipMethodInfo
    ResolveActionRowMethod "setHasWindow" o = Gtk.Widget.WidgetSetHasWindowMethodInfo
    ResolveActionRowMethod "setHeader" o = Gtk.ListBoxRow.ListBoxRowSetHeaderMethodInfo
    ResolveActionRowMethod "setHexpand" o = Gtk.Widget.WidgetSetHexpandMethodInfo
    ResolveActionRowMethod "setHexpandSet" o = Gtk.Widget.WidgetSetHexpandSetMethodInfo
    ResolveActionRowMethod "setIconName" o = ActionRowSetIconNameMethodInfo
    ResolveActionRowMethod "setMapped" o = Gtk.Widget.WidgetSetMappedMethodInfo
    ResolveActionRowMethod "setMarginBottom" o = Gtk.Widget.WidgetSetMarginBottomMethodInfo
    ResolveActionRowMethod "setMarginEnd" o = Gtk.Widget.WidgetSetMarginEndMethodInfo
    ResolveActionRowMethod "setMarginLeft" o = Gtk.Widget.WidgetSetMarginLeftMethodInfo
    ResolveActionRowMethod "setMarginRight" o = Gtk.Widget.WidgetSetMarginRightMethodInfo
    ResolveActionRowMethod "setMarginStart" o = Gtk.Widget.WidgetSetMarginStartMethodInfo
    ResolveActionRowMethod "setMarginTop" o = Gtk.Widget.WidgetSetMarginTopMethodInfo
    ResolveActionRowMethod "setName" o = Gtk.Widget.WidgetSetNameMethodInfo
    ResolveActionRowMethod "setNoShowAll" o = Gtk.Widget.WidgetSetNoShowAllMethodInfo
    ResolveActionRowMethod "setOpacity" o = Gtk.Widget.WidgetSetOpacityMethodInfo
    ResolveActionRowMethod "setParent" o = Gtk.Widget.WidgetSetParentMethodInfo
    ResolveActionRowMethod "setParentWindow" o = Gtk.Widget.WidgetSetParentWindowMethodInfo
    ResolveActionRowMethod "setProperty" o = GObject.Object.ObjectSetPropertyMethodInfo
    ResolveActionRowMethod "setRealized" o = Gtk.Widget.WidgetSetRealizedMethodInfo
    ResolveActionRowMethod "setReallocateRedraws" o = Gtk.Container.ContainerSetReallocateRedrawsMethodInfo
    ResolveActionRowMethod "setReceivesDefault" o = Gtk.Widget.WidgetSetReceivesDefaultMethodInfo
    ResolveActionRowMethod "setRedrawOnAllocate" o = Gtk.Widget.WidgetSetRedrawOnAllocateMethodInfo
    ResolveActionRowMethod "setResizeMode" o = Gtk.Container.ContainerSetResizeModeMethodInfo
    ResolveActionRowMethod "setSelectable" o = Gtk.ListBoxRow.ListBoxRowSetSelectableMethodInfo
    ResolveActionRowMethod "setSensitive" o = Gtk.Widget.WidgetSetSensitiveMethodInfo
    ResolveActionRowMethod "setSizeRequest" o = Gtk.Widget.WidgetSetSizeRequestMethodInfo
    ResolveActionRowMethod "setState" o = Gtk.Widget.WidgetSetStateMethodInfo
    ResolveActionRowMethod "setStateFlags" o = Gtk.Widget.WidgetSetStateFlagsMethodInfo
    ResolveActionRowMethod "setStyle" o = Gtk.Widget.WidgetSetStyleMethodInfo
    ResolveActionRowMethod "setSubtitle" o = ActionRowSetSubtitleMethodInfo
    ResolveActionRowMethod "setSupportMultidevice" o = Gtk.Widget.WidgetSetSupportMultideviceMethodInfo
    ResolveActionRowMethod "setTitle" o = ActionRowSetTitleMethodInfo
    ResolveActionRowMethod "setTooltipMarkup" o = Gtk.Widget.WidgetSetTooltipMarkupMethodInfo
    ResolveActionRowMethod "setTooltipText" o = Gtk.Widget.WidgetSetTooltipTextMethodInfo
    ResolveActionRowMethod "setTooltipWindow" o = Gtk.Widget.WidgetSetTooltipWindowMethodInfo
    ResolveActionRowMethod "setUseUnderline" o = ActionRowSetUseUnderlineMethodInfo
    ResolveActionRowMethod "setValign" o = Gtk.Widget.WidgetSetValignMethodInfo
    ResolveActionRowMethod "setVexpand" o = Gtk.Widget.WidgetSetVexpandMethodInfo
    ResolveActionRowMethod "setVexpandSet" o = Gtk.Widget.WidgetSetVexpandSetMethodInfo
    ResolveActionRowMethod "setVisible" o = Gtk.Widget.WidgetSetVisibleMethodInfo
    ResolveActionRowMethod "setVisual" o = Gtk.Widget.WidgetSetVisualMethodInfo
    ResolveActionRowMethod "setWindow" o = Gtk.Widget.WidgetSetWindowMethodInfo
    ResolveActionRowMethod l o = O.MethodResolutionFailed l o

instance (info ~ ResolveActionRowMethod t ActionRow, O.MethodInfo info ActionRow p) => OL.IsLabel t (ActionRow -> p) where
#if MIN_VERSION_base(4,10,0)
    fromLabel = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#else
    fromLabel _ = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#endif

#endif

-- VVV Prop "activatable-widget"
   -- Type: TInterface (Name {namespace = "Gtk", name = "Widget"})
   -- Flags: [PropertyReadable,PropertyWritable]
   -- Nullable: (Just True,Just True)

{- |
Get the value of the “@activatable-widget@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' actionRow #activatableWidget
@
-}
getActionRowActivatableWidget :: (MonadIO m, IsActionRow o) => o -> m (Maybe Gtk.Widget.Widget)
getActionRowActivatableWidget obj = liftIO $ B.Properties.getObjectPropertyObject obj "activatable-widget" Gtk.Widget.Widget

{- |
Set the value of the “@activatable-widget@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' actionRow [ #activatableWidget 'Data.GI.Base.Attributes.:=' value ]
@
-}
setActionRowActivatableWidget :: (MonadIO m, IsActionRow o, Gtk.Widget.IsWidget a) => o -> a -> m ()
setActionRowActivatableWidget obj val = liftIO $ B.Properties.setObjectPropertyObject obj "activatable-widget" (Just val)

{- |
Construct a `GValueConstruct` with valid value for the “@activatable-widget@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructActionRowActivatableWidget :: (IsActionRow o, Gtk.Widget.IsWidget a) => a -> IO (GValueConstruct o)
constructActionRowActivatableWidget val = B.Properties.constructObjectPropertyObject "activatable-widget" (Just val)

{- |
Set the value of the “@activatable-widget@” property to `Nothing`.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.clear' #activatableWidget
@
-}
clearActionRowActivatableWidget :: (MonadIO m, IsActionRow o) => o -> m ()
clearActionRowActivatableWidget obj = liftIO $ B.Properties.setObjectPropertyObject obj "activatable-widget" (Nothing :: Maybe Gtk.Widget.Widget)

#if ENABLE_OVERLOADING
data ActionRowActivatableWidgetPropertyInfo
instance AttrInfo ActionRowActivatableWidgetPropertyInfo where
    type AttrAllowedOps ActionRowActivatableWidgetPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint ActionRowActivatableWidgetPropertyInfo = Gtk.Widget.IsWidget
    type AttrBaseTypeConstraint ActionRowActivatableWidgetPropertyInfo = IsActionRow
    type AttrGetType ActionRowActivatableWidgetPropertyInfo = (Maybe Gtk.Widget.Widget)
    type AttrLabel ActionRowActivatableWidgetPropertyInfo = "activatable-widget"
    type AttrOrigin ActionRowActivatableWidgetPropertyInfo = ActionRow
    attrGet _ = getActionRowActivatableWidget
    attrSet _ = setActionRowActivatableWidget
    attrConstruct _ = constructActionRowActivatableWidget
    attrClear _ = clearActionRowActivatableWidget
#endif

-- VVV Prop "icon-name"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@icon-name@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' actionRow #iconName
@
-}
getActionRowIconName :: (MonadIO m, IsActionRow o) => o -> m T.Text
getActionRowIconName obj = liftIO $ checkUnexpectedNothing "getActionRowIconName" $ B.Properties.getObjectPropertyString obj "icon-name"

{- |
Set the value of the “@icon-name@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' actionRow [ #iconName 'Data.GI.Base.Attributes.:=' value ]
@
-}
setActionRowIconName :: (MonadIO m, IsActionRow o) => o -> T.Text -> m ()
setActionRowIconName obj val = liftIO $ B.Properties.setObjectPropertyString obj "icon-name" (Just val)

{- |
Construct a `GValueConstruct` with valid value for the “@icon-name@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructActionRowIconName :: (IsActionRow o) => T.Text -> IO (GValueConstruct o)
constructActionRowIconName val = B.Properties.constructObjectPropertyString "icon-name" (Just val)

#if ENABLE_OVERLOADING
data ActionRowIconNamePropertyInfo
instance AttrInfo ActionRowIconNamePropertyInfo where
    type AttrAllowedOps ActionRowIconNamePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint ActionRowIconNamePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint ActionRowIconNamePropertyInfo = IsActionRow
    type AttrGetType ActionRowIconNamePropertyInfo = T.Text
    type AttrLabel ActionRowIconNamePropertyInfo = "icon-name"
    type AttrOrigin ActionRowIconNamePropertyInfo = ActionRow
    attrGet _ = getActionRowIconName
    attrSet _ = setActionRowIconName
    attrConstruct _ = constructActionRowIconName
    attrClear _ = undefined
#endif

-- VVV Prop "subtitle"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@subtitle@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' actionRow #subtitle
@
-}
getActionRowSubtitle :: (MonadIO m, IsActionRow o) => o -> m T.Text
getActionRowSubtitle obj = liftIO $ checkUnexpectedNothing "getActionRowSubtitle" $ B.Properties.getObjectPropertyString obj "subtitle"

{- |
Set the value of the “@subtitle@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' actionRow [ #subtitle 'Data.GI.Base.Attributes.:=' value ]
@
-}
setActionRowSubtitle :: (MonadIO m, IsActionRow o) => o -> T.Text -> m ()
setActionRowSubtitle obj val = liftIO $ B.Properties.setObjectPropertyString obj "subtitle" (Just val)

{- |
Construct a `GValueConstruct` with valid value for the “@subtitle@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructActionRowSubtitle :: (IsActionRow o) => T.Text -> IO (GValueConstruct o)
constructActionRowSubtitle val = B.Properties.constructObjectPropertyString "subtitle" (Just val)

#if ENABLE_OVERLOADING
data ActionRowSubtitlePropertyInfo
instance AttrInfo ActionRowSubtitlePropertyInfo where
    type AttrAllowedOps ActionRowSubtitlePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint ActionRowSubtitlePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint ActionRowSubtitlePropertyInfo = IsActionRow
    type AttrGetType ActionRowSubtitlePropertyInfo = T.Text
    type AttrLabel ActionRowSubtitlePropertyInfo = "subtitle"
    type AttrOrigin ActionRowSubtitlePropertyInfo = ActionRow
    attrGet _ = getActionRowSubtitle
    attrSet _ = setActionRowSubtitle
    attrConstruct _ = constructActionRowSubtitle
    attrClear _ = undefined
#endif

-- VVV Prop "title"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@title@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' actionRow #title
@
-}
getActionRowTitle :: (MonadIO m, IsActionRow o) => o -> m T.Text
getActionRowTitle obj = liftIO $ checkUnexpectedNothing "getActionRowTitle" $ B.Properties.getObjectPropertyString obj "title"

{- |
Set the value of the “@title@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' actionRow [ #title 'Data.GI.Base.Attributes.:=' value ]
@
-}
setActionRowTitle :: (MonadIO m, IsActionRow o) => o -> T.Text -> m ()
setActionRowTitle obj val = liftIO $ B.Properties.setObjectPropertyString obj "title" (Just val)

{- |
Construct a `GValueConstruct` with valid value for the “@title@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructActionRowTitle :: (IsActionRow o) => T.Text -> IO (GValueConstruct o)
constructActionRowTitle val = B.Properties.constructObjectPropertyString "title" (Just val)

#if ENABLE_OVERLOADING
data ActionRowTitlePropertyInfo
instance AttrInfo ActionRowTitlePropertyInfo where
    type AttrAllowedOps ActionRowTitlePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint ActionRowTitlePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint ActionRowTitlePropertyInfo = IsActionRow
    type AttrGetType ActionRowTitlePropertyInfo = T.Text
    type AttrLabel ActionRowTitlePropertyInfo = "title"
    type AttrOrigin ActionRowTitlePropertyInfo = ActionRow
    attrGet _ = getActionRowTitle
    attrSet _ = setActionRowTitle
    attrConstruct _ = constructActionRowTitle
    attrClear _ = undefined
#endif

-- VVV Prop "use-underline"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@use-underline@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' actionRow #useUnderline
@
-}
getActionRowUseUnderline :: (MonadIO m, IsActionRow o) => o -> m Bool
getActionRowUseUnderline obj = liftIO $ B.Properties.getObjectPropertyBool obj "use-underline"

{- |
Set the value of the “@use-underline@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' actionRow [ #useUnderline 'Data.GI.Base.Attributes.:=' value ]
@
-}
setActionRowUseUnderline :: (MonadIO m, IsActionRow o) => o -> Bool -> m ()
setActionRowUseUnderline obj val = liftIO $ B.Properties.setObjectPropertyBool obj "use-underline" val

{- |
Construct a `GValueConstruct` with valid value for the “@use-underline@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructActionRowUseUnderline :: (IsActionRow o) => Bool -> IO (GValueConstruct o)
constructActionRowUseUnderline val = B.Properties.constructObjectPropertyBool "use-underline" val

#if ENABLE_OVERLOADING
data ActionRowUseUnderlinePropertyInfo
instance AttrInfo ActionRowUseUnderlinePropertyInfo where
    type AttrAllowedOps ActionRowUseUnderlinePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint ActionRowUseUnderlinePropertyInfo = (~) Bool
    type AttrBaseTypeConstraint ActionRowUseUnderlinePropertyInfo = IsActionRow
    type AttrGetType ActionRowUseUnderlinePropertyInfo = Bool
    type AttrLabel ActionRowUseUnderlinePropertyInfo = "use-underline"
    type AttrOrigin ActionRowUseUnderlinePropertyInfo = ActionRow
    attrGet _ = getActionRowUseUnderline
    attrSet _ = setActionRowUseUnderline
    attrConstruct _ = constructActionRowUseUnderline
    attrClear _ = undefined
#endif

#if ENABLE_OVERLOADING
instance O.HasAttributeList ActionRow
type instance O.AttributeList ActionRow = ActionRowAttributeList
type ActionRowAttributeList = ('[ '("actionName", Gtk.Actionable.ActionableActionNamePropertyInfo), '("actionTarget", Gtk.Actionable.ActionableActionTargetPropertyInfo), '("activatable", Gtk.ListBoxRow.ListBoxRowActivatablePropertyInfo), '("activatableWidget", ActionRowActivatableWidgetPropertyInfo), '("appPaintable", Gtk.Widget.WidgetAppPaintablePropertyInfo), '("borderWidth", Gtk.Container.ContainerBorderWidthPropertyInfo), '("canDefault", Gtk.Widget.WidgetCanDefaultPropertyInfo), '("canFocus", Gtk.Widget.WidgetCanFocusPropertyInfo), '("child", Gtk.Container.ContainerChildPropertyInfo), '("compositeChild", Gtk.Widget.WidgetCompositeChildPropertyInfo), '("doubleBuffered", Gtk.Widget.WidgetDoubleBufferedPropertyInfo), '("events", Gtk.Widget.WidgetEventsPropertyInfo), '("expand", Gtk.Widget.WidgetExpandPropertyInfo), '("focusOnClick", Gtk.Widget.WidgetFocusOnClickPropertyInfo), '("halign", Gtk.Widget.WidgetHalignPropertyInfo), '("hasDefault", Gtk.Widget.WidgetHasDefaultPropertyInfo), '("hasFocus", Gtk.Widget.WidgetHasFocusPropertyInfo), '("hasTooltip", Gtk.Widget.WidgetHasTooltipPropertyInfo), '("heightRequest", Gtk.Widget.WidgetHeightRequestPropertyInfo), '("hexpand", Gtk.Widget.WidgetHexpandPropertyInfo), '("hexpandSet", Gtk.Widget.WidgetHexpandSetPropertyInfo), '("iconName", ActionRowIconNamePropertyInfo), '("isFocus", Gtk.Widget.WidgetIsFocusPropertyInfo), '("margin", Gtk.Widget.WidgetMarginPropertyInfo), '("marginBottom", Gtk.Widget.WidgetMarginBottomPropertyInfo), '("marginEnd", Gtk.Widget.WidgetMarginEndPropertyInfo), '("marginLeft", Gtk.Widget.WidgetMarginLeftPropertyInfo), '("marginRight", Gtk.Widget.WidgetMarginRightPropertyInfo), '("marginStart", Gtk.Widget.WidgetMarginStartPropertyInfo), '("marginTop", Gtk.Widget.WidgetMarginTopPropertyInfo), '("name", Gtk.Widget.WidgetNamePropertyInfo), '("noShowAll", Gtk.Widget.WidgetNoShowAllPropertyInfo), '("opacity", Gtk.Widget.WidgetOpacityPropertyInfo), '("parent", Gtk.Widget.WidgetParentPropertyInfo), '("receivesDefault", Gtk.Widget.WidgetReceivesDefaultPropertyInfo), '("resizeMode", Gtk.Container.ContainerResizeModePropertyInfo), '("scaleFactor", Gtk.Widget.WidgetScaleFactorPropertyInfo), '("selectable", Gtk.ListBoxRow.ListBoxRowSelectablePropertyInfo), '("sensitive", Gtk.Widget.WidgetSensitivePropertyInfo), '("style", Gtk.Widget.WidgetStylePropertyInfo), '("subtitle", ActionRowSubtitlePropertyInfo), '("title", ActionRowTitlePropertyInfo), '("tooltipMarkup", Gtk.Widget.WidgetTooltipMarkupPropertyInfo), '("tooltipText", Gtk.Widget.WidgetTooltipTextPropertyInfo), '("useUnderline", ActionRowUseUnderlinePropertyInfo), '("valign", Gtk.Widget.WidgetValignPropertyInfo), '("vexpand", Gtk.Widget.WidgetVexpandPropertyInfo), '("vexpandSet", Gtk.Widget.WidgetVexpandSetPropertyInfo), '("visible", Gtk.Widget.WidgetVisiblePropertyInfo), '("widthRequest", Gtk.Widget.WidgetWidthRequestPropertyInfo), '("window", Gtk.Widget.WidgetWindowPropertyInfo)] :: [(Symbol, *)])
#endif

#if ENABLE_OVERLOADING
actionRowActivatableWidget :: AttrLabelProxy "activatableWidget"
actionRowActivatableWidget = AttrLabelProxy

actionRowIconName :: AttrLabelProxy "iconName"
actionRowIconName = AttrLabelProxy

actionRowSubtitle :: AttrLabelProxy "subtitle"
actionRowSubtitle = AttrLabelProxy

actionRowTitle :: AttrLabelProxy "title"
actionRowTitle = AttrLabelProxy

actionRowUseUnderline :: AttrLabelProxy "useUnderline"
actionRowUseUnderline = AttrLabelProxy

#endif

#if ENABLE_OVERLOADING
type instance O.SignalList ActionRow = ActionRowSignalList
type ActionRowSignalList = ('[ '("accelClosuresChanged", Gtk.Widget.WidgetAccelClosuresChangedSignalInfo), '("activate", Gtk.ListBoxRow.ListBoxRowActivateSignalInfo), '("add", Gtk.Container.ContainerAddSignalInfo), '("buttonPressEvent", Gtk.Widget.WidgetButtonPressEventSignalInfo), '("buttonReleaseEvent", Gtk.Widget.WidgetButtonReleaseEventSignalInfo), '("canActivateAccel", Gtk.Widget.WidgetCanActivateAccelSignalInfo), '("checkResize", Gtk.Container.ContainerCheckResizeSignalInfo), '("childNotify", Gtk.Widget.WidgetChildNotifySignalInfo), '("compositedChanged", Gtk.Widget.WidgetCompositedChangedSignalInfo), '("configureEvent", Gtk.Widget.WidgetConfigureEventSignalInfo), '("damageEvent", Gtk.Widget.WidgetDamageEventSignalInfo), '("deleteEvent", Gtk.Widget.WidgetDeleteEventSignalInfo), '("destroy", Gtk.Widget.WidgetDestroySignalInfo), '("destroyEvent", Gtk.Widget.WidgetDestroyEventSignalInfo), '("directionChanged", Gtk.Widget.WidgetDirectionChangedSignalInfo), '("dragBegin", Gtk.Widget.WidgetDragBeginSignalInfo), '("dragDataDelete", Gtk.Widget.WidgetDragDataDeleteSignalInfo), '("dragDataGet", Gtk.Widget.WidgetDragDataGetSignalInfo), '("dragDataReceived", Gtk.Widget.WidgetDragDataReceivedSignalInfo), '("dragDrop", Gtk.Widget.WidgetDragDropSignalInfo), '("dragEnd", Gtk.Widget.WidgetDragEndSignalInfo), '("dragFailed", Gtk.Widget.WidgetDragFailedSignalInfo), '("dragLeave", Gtk.Widget.WidgetDragLeaveSignalInfo), '("dragMotion", Gtk.Widget.WidgetDragMotionSignalInfo), '("draw", Gtk.Widget.WidgetDrawSignalInfo), '("enterNotifyEvent", Gtk.Widget.WidgetEnterNotifyEventSignalInfo), '("event", Gtk.Widget.WidgetEventSignalInfo), '("eventAfter", Gtk.Widget.WidgetEventAfterSignalInfo), '("focus", Gtk.Widget.WidgetFocusSignalInfo), '("focusInEvent", Gtk.Widget.WidgetFocusInEventSignalInfo), '("focusOutEvent", Gtk.Widget.WidgetFocusOutEventSignalInfo), '("grabBrokenEvent", Gtk.Widget.WidgetGrabBrokenEventSignalInfo), '("grabFocus", Gtk.Widget.WidgetGrabFocusSignalInfo), '("grabNotify", Gtk.Widget.WidgetGrabNotifySignalInfo), '("hide", Gtk.Widget.WidgetHideSignalInfo), '("hierarchyChanged", Gtk.Widget.WidgetHierarchyChangedSignalInfo), '("keyPressEvent", Gtk.Widget.WidgetKeyPressEventSignalInfo), '("keyReleaseEvent", Gtk.Widget.WidgetKeyReleaseEventSignalInfo), '("keynavFailed", Gtk.Widget.WidgetKeynavFailedSignalInfo), '("leaveNotifyEvent", Gtk.Widget.WidgetLeaveNotifyEventSignalInfo), '("map", Gtk.Widget.WidgetMapSignalInfo), '("mapEvent", Gtk.Widget.WidgetMapEventSignalInfo), '("mnemonicActivate", Gtk.Widget.WidgetMnemonicActivateSignalInfo), '("motionNotifyEvent", Gtk.Widget.WidgetMotionNotifyEventSignalInfo), '("moveFocus", Gtk.Widget.WidgetMoveFocusSignalInfo), '("notify", GObject.Object.ObjectNotifySignalInfo), '("parentSet", Gtk.Widget.WidgetParentSetSignalInfo), '("popupMenu", Gtk.Widget.WidgetPopupMenuSignalInfo), '("propertyNotifyEvent", Gtk.Widget.WidgetPropertyNotifyEventSignalInfo), '("proximityInEvent", Gtk.Widget.WidgetProximityInEventSignalInfo), '("proximityOutEvent", Gtk.Widget.WidgetProximityOutEventSignalInfo), '("queryTooltip", Gtk.Widget.WidgetQueryTooltipSignalInfo), '("realize", Gtk.Widget.WidgetRealizeSignalInfo), '("remove", Gtk.Container.ContainerRemoveSignalInfo), '("screenChanged", Gtk.Widget.WidgetScreenChangedSignalInfo), '("scrollEvent", Gtk.Widget.WidgetScrollEventSignalInfo), '("selectionClearEvent", Gtk.Widget.WidgetSelectionClearEventSignalInfo), '("selectionGet", Gtk.Widget.WidgetSelectionGetSignalInfo), '("selectionNotifyEvent", Gtk.Widget.WidgetSelectionNotifyEventSignalInfo), '("selectionReceived", Gtk.Widget.WidgetSelectionReceivedSignalInfo), '("selectionRequestEvent", Gtk.Widget.WidgetSelectionRequestEventSignalInfo), '("setFocusChild", Gtk.Container.ContainerSetFocusChildSignalInfo), '("show", Gtk.Widget.WidgetShowSignalInfo), '("showHelp", Gtk.Widget.WidgetShowHelpSignalInfo), '("sizeAllocate", Gtk.Widget.WidgetSizeAllocateSignalInfo), '("stateChanged", Gtk.Widget.WidgetStateChangedSignalInfo), '("stateFlagsChanged", Gtk.Widget.WidgetStateFlagsChangedSignalInfo), '("styleSet", Gtk.Widget.WidgetStyleSetSignalInfo), '("styleUpdated", Gtk.Widget.WidgetStyleUpdatedSignalInfo), '("touchEvent", Gtk.Widget.WidgetTouchEventSignalInfo), '("unmap", Gtk.Widget.WidgetUnmapSignalInfo), '("unmapEvent", Gtk.Widget.WidgetUnmapEventSignalInfo), '("unrealize", Gtk.Widget.WidgetUnrealizeSignalInfo), '("visibilityNotifyEvent", Gtk.Widget.WidgetVisibilityNotifyEventSignalInfo), '("windowStateEvent", Gtk.Widget.WidgetWindowStateEventSignalInfo)] :: [(Symbol, *)])

#endif

-- method ActionRow::new
-- method type : Constructor
-- Args : []
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "Handy", name = "ActionRow"}))
-- throws : False
-- Skip return : False

foreign import ccall "hdy_action_row_new" hdy_action_row_new :: 
    IO (Ptr ActionRow)

{- |
Creates a new 'GI.Handy.Objects.ActionRow.ActionRow'.

/Since: 0.0.6/
-}
actionRowNew ::
    (B.CallStack.HasCallStack, MonadIO m) =>
    m ActionRow
    {- ^ __Returns:__ a new 'GI.Handy.Objects.ActionRow.ActionRow' -}
actionRowNew  = liftIO $ do
    result <- hdy_action_row_new
    checkUnexpectedReturnNULL "actionRowNew" result
    result' <- (newObject ActionRow) result
    return result'

#if ENABLE_OVERLOADING
#endif

-- method ActionRow::activate
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "Handy", name = "ActionRow"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Nothing, sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "hdy_action_row_activate" hdy_action_row_activate :: 
    Ptr ActionRow ->                        -- self : TInterface (Name {namespace = "Handy", name = "ActionRow"})
    IO ()

{- |
/No description available in the introspection data./
-}
actionRowActivate ::
    (B.CallStack.HasCallStack, MonadIO m, IsActionRow a) =>
    a
    -> m ()
actionRowActivate self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    hdy_action_row_activate self'
    touchManagedPtr self
    return ()

#if ENABLE_OVERLOADING
data ActionRowActivateMethodInfo
instance (signature ~ (m ()), MonadIO m, IsActionRow a) => O.MethodInfo ActionRowActivateMethodInfo a signature where
    overloadedMethod _ = actionRowActivate

#endif

-- method ActionRow::add_action
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "Handy", name = "ActionRow"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #HdyActionRow", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "widget", argType = TInterface (Name {namespace = "Gtk", name = "Widget"}), direction = DirectionIn, mayBeNull = True, argDoc = Documentation {rawDocText = Just "the action widget", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "hdy_action_row_add_action" hdy_action_row_add_action :: 
    Ptr ActionRow ->                        -- self : TInterface (Name {namespace = "Handy", name = "ActionRow"})
    Ptr Gtk.Widget.Widget ->                -- widget : TInterface (Name {namespace = "Gtk", name = "Widget"})
    IO ()

{- |
Adds an action widget to /@self@/.

/Since: 0.0.6/
-}
actionRowAddAction ::
    (B.CallStack.HasCallStack, MonadIO m, IsActionRow a, Gtk.Widget.IsWidget b) =>
    a
    {- ^ /@self@/: a 'GI.Handy.Objects.ActionRow.ActionRow' -}
    -> Maybe (b)
    {- ^ /@widget@/: the action widget -}
    -> m ()
actionRowAddAction self widget = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    maybeWidget <- case widget of
        Nothing -> return nullPtr
        Just jWidget -> do
            jWidget' <- unsafeManagedPtrCastPtr jWidget
            return jWidget'
    hdy_action_row_add_action self' maybeWidget
    touchManagedPtr self
    whenJust widget touchManagedPtr
    return ()

#if ENABLE_OVERLOADING
data ActionRowAddActionMethodInfo
instance (signature ~ (Maybe (b) -> m ()), MonadIO m, IsActionRow a, Gtk.Widget.IsWidget b) => O.MethodInfo ActionRowAddActionMethodInfo a signature where
    overloadedMethod _ = actionRowAddAction

#endif

-- method ActionRow::add_prefix
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "Handy", name = "ActionRow"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #HdyActionRow", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "widget", argType = TInterface (Name {namespace = "Gtk", name = "Widget"}), direction = DirectionIn, mayBeNull = True, argDoc = Documentation {rawDocText = Just "the prefix widget", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "hdy_action_row_add_prefix" hdy_action_row_add_prefix :: 
    Ptr ActionRow ->                        -- self : TInterface (Name {namespace = "Handy", name = "ActionRow"})
    Ptr Gtk.Widget.Widget ->                -- widget : TInterface (Name {namespace = "Gtk", name = "Widget"})
    IO ()

{- |
Adds a prefix widget to /@self@/.

/Since: 0.0.6/
-}
actionRowAddPrefix ::
    (B.CallStack.HasCallStack, MonadIO m, IsActionRow a, Gtk.Widget.IsWidget b) =>
    a
    {- ^ /@self@/: a 'GI.Handy.Objects.ActionRow.ActionRow' -}
    -> Maybe (b)
    {- ^ /@widget@/: the prefix widget -}
    -> m ()
actionRowAddPrefix self widget = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    maybeWidget <- case widget of
        Nothing -> return nullPtr
        Just jWidget -> do
            jWidget' <- unsafeManagedPtrCastPtr jWidget
            return jWidget'
    hdy_action_row_add_prefix self' maybeWidget
    touchManagedPtr self
    whenJust widget touchManagedPtr
    return ()

#if ENABLE_OVERLOADING
data ActionRowAddPrefixMethodInfo
instance (signature ~ (Maybe (b) -> m ()), MonadIO m, IsActionRow a, Gtk.Widget.IsWidget b) => O.MethodInfo ActionRowAddPrefixMethodInfo a signature where
    overloadedMethod _ = actionRowAddPrefix

#endif

-- method ActionRow::get_activatable_widget
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "Handy", name = "ActionRow"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #HdyActionRow", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "Gtk", name = "Widget"}))
-- throws : False
-- Skip return : False

foreign import ccall "hdy_action_row_get_activatable_widget" hdy_action_row_get_activatable_widget :: 
    Ptr ActionRow ->                        -- self : TInterface (Name {namespace = "Handy", name = "ActionRow"})
    IO (Ptr Gtk.Widget.Widget)

{- |
Gets the widget activated when /@self@/ is activated.

/Since: 0.0.7/
-}
actionRowGetActivatableWidget ::
    (B.CallStack.HasCallStack, MonadIO m, IsActionRow a) =>
    a
    {- ^ /@self@/: a 'GI.Handy.Objects.ActionRow.ActionRow' -}
    -> m (Maybe Gtk.Widget.Widget)
    {- ^ __Returns:__ the widget activated when /@self@/ is
         activated, or 'Nothing' if none has been set. -}
actionRowGetActivatableWidget self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- hdy_action_row_get_activatable_widget self'
    maybeResult <- convertIfNonNull result $ \result' -> do
        result'' <- (newObject Gtk.Widget.Widget) result'
        return result''
    touchManagedPtr self
    return maybeResult

#if ENABLE_OVERLOADING
data ActionRowGetActivatableWidgetMethodInfo
instance (signature ~ (m (Maybe Gtk.Widget.Widget)), MonadIO m, IsActionRow a) => O.MethodInfo ActionRowGetActivatableWidgetMethodInfo a signature where
    overloadedMethod _ = actionRowGetActivatableWidget

#endif

-- method ActionRow::get_icon_name
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "Handy", name = "ActionRow"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #HdyActionRow", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUTF8)
-- throws : False
-- Skip return : False

foreign import ccall "hdy_action_row_get_icon_name" hdy_action_row_get_icon_name :: 
    Ptr ActionRow ->                        -- self : TInterface (Name {namespace = "Handy", name = "ActionRow"})
    IO CString

{- |
Gets the icon name for /@self@/.

/Since: 0.0.6/
-}
actionRowGetIconName ::
    (B.CallStack.HasCallStack, MonadIO m, IsActionRow a) =>
    a
    {- ^ /@self@/: a 'GI.Handy.Objects.ActionRow.ActionRow' -}
    -> m T.Text
    {- ^ __Returns:__ the icon name for /@self@/. -}
actionRowGetIconName self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- hdy_action_row_get_icon_name self'
    checkUnexpectedReturnNULL "actionRowGetIconName" result
    result' <- cstringToText result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data ActionRowGetIconNameMethodInfo
instance (signature ~ (m T.Text), MonadIO m, IsActionRow a) => O.MethodInfo ActionRowGetIconNameMethodInfo a signature where
    overloadedMethod _ = actionRowGetIconName

#endif

-- method ActionRow::get_subtitle
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "Handy", name = "ActionRow"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #HdyActionRow", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUTF8)
-- throws : False
-- Skip return : False

foreign import ccall "hdy_action_row_get_subtitle" hdy_action_row_get_subtitle :: 
    Ptr ActionRow ->                        -- self : TInterface (Name {namespace = "Handy", name = "ActionRow"})
    IO CString

{- |
Gets the subtitle for /@self@/.

/Since: 0.0.6/
-}
actionRowGetSubtitle ::
    (B.CallStack.HasCallStack, MonadIO m, IsActionRow a) =>
    a
    {- ^ /@self@/: a 'GI.Handy.Objects.ActionRow.ActionRow' -}
    -> m T.Text
    {- ^ __Returns:__ the subtitle for /@self@/. -}
actionRowGetSubtitle self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- hdy_action_row_get_subtitle self'
    checkUnexpectedReturnNULL "actionRowGetSubtitle" result
    result' <- cstringToText result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data ActionRowGetSubtitleMethodInfo
instance (signature ~ (m T.Text), MonadIO m, IsActionRow a) => O.MethodInfo ActionRowGetSubtitleMethodInfo a signature where
    overloadedMethod _ = actionRowGetSubtitle

#endif

-- method ActionRow::get_title
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "Handy", name = "ActionRow"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #HdyActionRow", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUTF8)
-- throws : False
-- Skip return : False

foreign import ccall "hdy_action_row_get_title" hdy_action_row_get_title :: 
    Ptr ActionRow ->                        -- self : TInterface (Name {namespace = "Handy", name = "ActionRow"})
    IO CString

{- |
Gets the title for /@self@/.

/Since: 0.0.6/
-}
actionRowGetTitle ::
    (B.CallStack.HasCallStack, MonadIO m, IsActionRow a) =>
    a
    {- ^ /@self@/: a 'GI.Handy.Objects.ActionRow.ActionRow' -}
    -> m T.Text
    {- ^ __Returns:__ the title for /@self@/. -}
actionRowGetTitle self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- hdy_action_row_get_title self'
    checkUnexpectedReturnNULL "actionRowGetTitle" result
    result' <- cstringToText result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data ActionRowGetTitleMethodInfo
instance (signature ~ (m T.Text), MonadIO m, IsActionRow a) => O.MethodInfo ActionRowGetTitleMethodInfo a signature where
    overloadedMethod _ = actionRowGetTitle

#endif

-- method ActionRow::get_use_underline
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "Handy", name = "ActionRow"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #HdyActionRow", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "hdy_action_row_get_use_underline" hdy_action_row_get_use_underline :: 
    Ptr ActionRow ->                        -- self : TInterface (Name {namespace = "Handy", name = "ActionRow"})
    IO CInt

{- |
Gets whether an embedded underline in the text of the title and subtitle
labels indicates a mnemonic. See 'GI.Handy.Objects.ActionRow.actionRowSetUseUnderline'.

/Since: 0.0.6/
-}
actionRowGetUseUnderline ::
    (B.CallStack.HasCallStack, MonadIO m, IsActionRow a) =>
    a
    {- ^ /@self@/: a 'GI.Handy.Objects.ActionRow.ActionRow' -}
    -> m Bool
    {- ^ __Returns:__ 'True' if an embedded underline in the title and subtitle labels
         indicates the mnemonic accelerator keys. -}
actionRowGetUseUnderline self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- hdy_action_row_get_use_underline self'
    let result' = (/= 0) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data ActionRowGetUseUnderlineMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsActionRow a) => O.MethodInfo ActionRowGetUseUnderlineMethodInfo a signature where
    overloadedMethod _ = actionRowGetUseUnderline

#endif

-- method ActionRow::set_activatable_widget
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "Handy", name = "ActionRow"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #HdyActionRow", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "widget", argType = TInterface (Name {namespace = "Gtk", name = "Widget"}), direction = DirectionIn, mayBeNull = True, argDoc = Documentation {rawDocText = Just "the target #GtkWidget, or %NULL to unset", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "hdy_action_row_set_activatable_widget" hdy_action_row_set_activatable_widget :: 
    Ptr ActionRow ->                        -- self : TInterface (Name {namespace = "Handy", name = "ActionRow"})
    Ptr Gtk.Widget.Widget ->                -- widget : TInterface (Name {namespace = "Gtk", name = "Widget"})
    IO ()

{- |
Sets the widget to activate when /@self@/ is activated, either by clicking
on it, by calling 'GI.Handy.Objects.ActionRow.actionRowActivate', or via mnemonics in the title or
the subtitle. See the “use_underline” property to enable mnemonics.

The target widget will be activated by emitting the
GtkWidget::mnemonic-activate signal on it.

/Since: 0.0.7/
-}
actionRowSetActivatableWidget ::
    (B.CallStack.HasCallStack, MonadIO m, IsActionRow a, Gtk.Widget.IsWidget b) =>
    a
    {- ^ /@self@/: a 'GI.Handy.Objects.ActionRow.ActionRow' -}
    -> Maybe (b)
    {- ^ /@widget@/: the target 'GI.Gtk.Objects.Widget.Widget', or 'Nothing' to unset -}
    -> m ()
actionRowSetActivatableWidget self widget = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    maybeWidget <- case widget of
        Nothing -> return nullPtr
        Just jWidget -> do
            jWidget' <- unsafeManagedPtrCastPtr jWidget
            return jWidget'
    hdy_action_row_set_activatable_widget self' maybeWidget
    touchManagedPtr self
    whenJust widget touchManagedPtr
    return ()

#if ENABLE_OVERLOADING
data ActionRowSetActivatableWidgetMethodInfo
instance (signature ~ (Maybe (b) -> m ()), MonadIO m, IsActionRow a, Gtk.Widget.IsWidget b) => O.MethodInfo ActionRowSetActivatableWidgetMethodInfo a signature where
    overloadedMethod _ = actionRowSetActivatableWidget

#endif

-- method ActionRow::set_icon_name
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "Handy", name = "ActionRow"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #HdyActionRow", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "icon_name", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "the icon name", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "hdy_action_row_set_icon_name" hdy_action_row_set_icon_name :: 
    Ptr ActionRow ->                        -- self : TInterface (Name {namespace = "Handy", name = "ActionRow"})
    CString ->                              -- icon_name : TBasicType TUTF8
    IO ()

{- |
Sets the icon name for /@self@/.

/Since: 0.0.6/
-}
actionRowSetIconName ::
    (B.CallStack.HasCallStack, MonadIO m, IsActionRow a) =>
    a
    {- ^ /@self@/: a 'GI.Handy.Objects.ActionRow.ActionRow' -}
    -> T.Text
    {- ^ /@iconName@/: the icon name -}
    -> m ()
actionRowSetIconName self iconName = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    iconName' <- textToCString iconName
    hdy_action_row_set_icon_name self' iconName'
    touchManagedPtr self
    freeMem iconName'
    return ()

#if ENABLE_OVERLOADING
data ActionRowSetIconNameMethodInfo
instance (signature ~ (T.Text -> m ()), MonadIO m, IsActionRow a) => O.MethodInfo ActionRowSetIconNameMethodInfo a signature where
    overloadedMethod _ = actionRowSetIconName

#endif

-- method ActionRow::set_subtitle
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "Handy", name = "ActionRow"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #HdyActionRow", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "subtitle", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "the subtitle", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "hdy_action_row_set_subtitle" hdy_action_row_set_subtitle :: 
    Ptr ActionRow ->                        -- self : TInterface (Name {namespace = "Handy", name = "ActionRow"})
    CString ->                              -- subtitle : TBasicType TUTF8
    IO ()

{- |
Sets the subtitle for /@self@/.

/Since: 0.0.6/
-}
actionRowSetSubtitle ::
    (B.CallStack.HasCallStack, MonadIO m, IsActionRow a) =>
    a
    {- ^ /@self@/: a 'GI.Handy.Objects.ActionRow.ActionRow' -}
    -> T.Text
    {- ^ /@subtitle@/: the subtitle -}
    -> m ()
actionRowSetSubtitle self subtitle = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    subtitle' <- textToCString subtitle
    hdy_action_row_set_subtitle self' subtitle'
    touchManagedPtr self
    freeMem subtitle'
    return ()

#if ENABLE_OVERLOADING
data ActionRowSetSubtitleMethodInfo
instance (signature ~ (T.Text -> m ()), MonadIO m, IsActionRow a) => O.MethodInfo ActionRowSetSubtitleMethodInfo a signature where
    overloadedMethod _ = actionRowSetSubtitle

#endif

-- method ActionRow::set_title
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "Handy", name = "ActionRow"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #HdyActionRow", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "title", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "the title", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "hdy_action_row_set_title" hdy_action_row_set_title :: 
    Ptr ActionRow ->                        -- self : TInterface (Name {namespace = "Handy", name = "ActionRow"})
    CString ->                              -- title : TBasicType TUTF8
    IO ()

{- |
Sets the title for /@self@/.

/Since: 0.0.6/
-}
actionRowSetTitle ::
    (B.CallStack.HasCallStack, MonadIO m, IsActionRow a) =>
    a
    {- ^ /@self@/: a 'GI.Handy.Objects.ActionRow.ActionRow' -}
    -> T.Text
    {- ^ /@title@/: the title -}
    -> m ()
actionRowSetTitle self title = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    title' <- textToCString title
    hdy_action_row_set_title self' title'
    touchManagedPtr self
    freeMem title'
    return ()

#if ENABLE_OVERLOADING
data ActionRowSetTitleMethodInfo
instance (signature ~ (T.Text -> m ()), MonadIO m, IsActionRow a) => O.MethodInfo ActionRowSetTitleMethodInfo a signature where
    overloadedMethod _ = actionRowSetTitle

#endif

-- method ActionRow::set_use_underline
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "Handy", name = "ActionRow"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #HdyActionRow", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "use_underline", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "%TRUE if underlines in the text indicate mnemonics", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "hdy_action_row_set_use_underline" hdy_action_row_set_use_underline :: 
    Ptr ActionRow ->                        -- self : TInterface (Name {namespace = "Handy", name = "ActionRow"})
    CInt ->                                 -- use_underline : TBasicType TBoolean
    IO ()

{- |
If true, an underline in the text of the title and subtitle labels indicates
the next character should be used for the mnemonic accelerator key.

/Since: 0.0.6/
-}
actionRowSetUseUnderline ::
    (B.CallStack.HasCallStack, MonadIO m, IsActionRow a) =>
    a
    {- ^ /@self@/: a 'GI.Handy.Objects.ActionRow.ActionRow' -}
    -> Bool
    {- ^ /@useUnderline@/: 'True' if underlines in the text indicate mnemonics -}
    -> m ()
actionRowSetUseUnderline self useUnderline = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    let useUnderline' = (fromIntegral . fromEnum) useUnderline
    hdy_action_row_set_use_underline self' useUnderline'
    touchManagedPtr self
    return ()

#if ENABLE_OVERLOADING
data ActionRowSetUseUnderlineMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsActionRow a) => O.MethodInfo ActionRowSetUseUnderlineMethodInfo a signature where
    overloadedMethod _ = actionRowSetUseUnderline

#endif


