

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)

/No description available in the introspection data./
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.Handy.Objects.Column
    ( 

-- * Exported types
    Column(..)                              ,
    IsColumn                                ,
    toColumn                                ,
    noColumn                                ,


 -- * Methods
-- ** getLinearGrowthWidth #method:getLinearGrowthWidth#

#if ENABLE_OVERLOADING
    ColumnGetLinearGrowthWidthMethodInfo    ,
#endif
    columnGetLinearGrowthWidth              ,


-- ** getMaximumWidth #method:getMaximumWidth#

#if ENABLE_OVERLOADING
    ColumnGetMaximumWidthMethodInfo         ,
#endif
    columnGetMaximumWidth                   ,


-- ** new #method:new#

    columnNew                               ,


-- ** setLinearGrowthWidth #method:setLinearGrowthWidth#

#if ENABLE_OVERLOADING
    ColumnSetLinearGrowthWidthMethodInfo    ,
#endif
    columnSetLinearGrowthWidth              ,


-- ** setMaximumWidth #method:setMaximumWidth#

#if ENABLE_OVERLOADING
    ColumnSetMaximumWidthMethodInfo         ,
#endif
    columnSetMaximumWidth                   ,




 -- * Properties
-- ** linearGrowthWidth #attr:linearGrowthWidth#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    ColumnLinearGrowthWidthPropertyInfo     ,
#endif
#if ENABLE_OVERLOADING
    columnLinearGrowthWidth                 ,
#endif
    constructColumnLinearGrowthWidth        ,
    getColumnLinearGrowthWidth              ,
    setColumnLinearGrowthWidth              ,


-- ** maximumWidth #attr:maximumWidth#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    ColumnMaximumWidthPropertyInfo          ,
#endif
#if ENABLE_OVERLOADING
    columnMaximumWidth                      ,
#endif
    constructColumnMaximumWidth             ,
    getColumnMaximumWidth                   ,
    setColumnMaximumWidth                   ,




    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL

import qualified GI.Atk.Interfaces.ImplementorIface as Atk.ImplementorIface
import qualified GI.GObject.Objects.Object as GObject.Object
import qualified GI.Gtk.Interfaces.Buildable as Gtk.Buildable
import qualified GI.Gtk.Objects.Bin as Gtk.Bin
import qualified GI.Gtk.Objects.Container as Gtk.Container
import qualified GI.Gtk.Objects.Widget as Gtk.Widget

-- | Memory-managed wrapper type.
newtype Column = Column (ManagedPtr Column)
foreign import ccall "hdy_column_get_type"
    c_hdy_column_get_type :: IO GType

instance GObject Column where
    gobjectType = c_hdy_column_get_type
    

-- | Type class for types which can be safely cast to `Column`, for instance with `toColumn`.
class (GObject o, O.IsDescendantOf Column o) => IsColumn o
instance (GObject o, O.IsDescendantOf Column o) => IsColumn o

instance O.HasParentTypes Column
type instance O.ParentTypes Column = '[Gtk.Bin.Bin, Gtk.Container.Container, Gtk.Widget.Widget, GObject.Object.Object, Atk.ImplementorIface.ImplementorIface, Gtk.Buildable.Buildable]

-- | Cast to `Column`, for types for which this is known to be safe. For general casts, use `Data.GI.Base.ManagedPtr.castTo`.
toColumn :: (MonadIO m, IsColumn o) => o -> m Column
toColumn = liftIO . unsafeCastTo Column

-- | A convenience alias for `Nothing` :: `Maybe` `Column`.
noColumn :: Maybe Column
noColumn = Nothing

#if ENABLE_OVERLOADING
type family ResolveColumnMethod (t :: Symbol) (o :: *) :: * where
    ResolveColumnMethod "activate" o = Gtk.Widget.WidgetActivateMethodInfo
    ResolveColumnMethod "add" o = Gtk.Container.ContainerAddMethodInfo
    ResolveColumnMethod "addAccelerator" o = Gtk.Widget.WidgetAddAcceleratorMethodInfo
    ResolveColumnMethod "addChild" o = Gtk.Buildable.BuildableAddChildMethodInfo
    ResolveColumnMethod "addDeviceEvents" o = Gtk.Widget.WidgetAddDeviceEventsMethodInfo
    ResolveColumnMethod "addEvents" o = Gtk.Widget.WidgetAddEventsMethodInfo
    ResolveColumnMethod "addMnemonicLabel" o = Gtk.Widget.WidgetAddMnemonicLabelMethodInfo
    ResolveColumnMethod "addTickCallback" o = Gtk.Widget.WidgetAddTickCallbackMethodInfo
    ResolveColumnMethod "bindProperty" o = GObject.Object.ObjectBindPropertyMethodInfo
    ResolveColumnMethod "bindPropertyFull" o = GObject.Object.ObjectBindPropertyFullMethodInfo
    ResolveColumnMethod "canActivateAccel" o = Gtk.Widget.WidgetCanActivateAccelMethodInfo
    ResolveColumnMethod "checkResize" o = Gtk.Container.ContainerCheckResizeMethodInfo
    ResolveColumnMethod "childFocus" o = Gtk.Widget.WidgetChildFocusMethodInfo
    ResolveColumnMethod "childGetProperty" o = Gtk.Container.ContainerChildGetPropertyMethodInfo
    ResolveColumnMethod "childNotify" o = Gtk.Container.ContainerChildNotifyMethodInfo
    ResolveColumnMethod "childNotifyByPspec" o = Gtk.Container.ContainerChildNotifyByPspecMethodInfo
    ResolveColumnMethod "childSetProperty" o = Gtk.Container.ContainerChildSetPropertyMethodInfo
    ResolveColumnMethod "childType" o = Gtk.Container.ContainerChildTypeMethodInfo
    ResolveColumnMethod "classPath" o = Gtk.Widget.WidgetClassPathMethodInfo
    ResolveColumnMethod "computeExpand" o = Gtk.Widget.WidgetComputeExpandMethodInfo
    ResolveColumnMethod "constructChild" o = Gtk.Buildable.BuildableConstructChildMethodInfo
    ResolveColumnMethod "createPangoContext" o = Gtk.Widget.WidgetCreatePangoContextMethodInfo
    ResolveColumnMethod "createPangoLayout" o = Gtk.Widget.WidgetCreatePangoLayoutMethodInfo
    ResolveColumnMethod "customFinished" o = Gtk.Buildable.BuildableCustomFinishedMethodInfo
    ResolveColumnMethod "customTagEnd" o = Gtk.Buildable.BuildableCustomTagEndMethodInfo
    ResolveColumnMethod "customTagStart" o = Gtk.Buildable.BuildableCustomTagStartMethodInfo
    ResolveColumnMethod "destroy" o = Gtk.Widget.WidgetDestroyMethodInfo
    ResolveColumnMethod "destroyed" o = Gtk.Widget.WidgetDestroyedMethodInfo
    ResolveColumnMethod "deviceIsShadowed" o = Gtk.Widget.WidgetDeviceIsShadowedMethodInfo
    ResolveColumnMethod "dragBegin" o = Gtk.Widget.WidgetDragBeginMethodInfo
    ResolveColumnMethod "dragBeginWithCoordinates" o = Gtk.Widget.WidgetDragBeginWithCoordinatesMethodInfo
    ResolveColumnMethod "dragCheckThreshold" o = Gtk.Widget.WidgetDragCheckThresholdMethodInfo
    ResolveColumnMethod "dragDestAddImageTargets" o = Gtk.Widget.WidgetDragDestAddImageTargetsMethodInfo
    ResolveColumnMethod "dragDestAddTextTargets" o = Gtk.Widget.WidgetDragDestAddTextTargetsMethodInfo
    ResolveColumnMethod "dragDestAddUriTargets" o = Gtk.Widget.WidgetDragDestAddUriTargetsMethodInfo
    ResolveColumnMethod "dragDestFindTarget" o = Gtk.Widget.WidgetDragDestFindTargetMethodInfo
    ResolveColumnMethod "dragDestGetTargetList" o = Gtk.Widget.WidgetDragDestGetTargetListMethodInfo
    ResolveColumnMethod "dragDestGetTrackMotion" o = Gtk.Widget.WidgetDragDestGetTrackMotionMethodInfo
    ResolveColumnMethod "dragDestSet" o = Gtk.Widget.WidgetDragDestSetMethodInfo
    ResolveColumnMethod "dragDestSetProxy" o = Gtk.Widget.WidgetDragDestSetProxyMethodInfo
    ResolveColumnMethod "dragDestSetTargetList" o = Gtk.Widget.WidgetDragDestSetTargetListMethodInfo
    ResolveColumnMethod "dragDestSetTrackMotion" o = Gtk.Widget.WidgetDragDestSetTrackMotionMethodInfo
    ResolveColumnMethod "dragDestUnset" o = Gtk.Widget.WidgetDragDestUnsetMethodInfo
    ResolveColumnMethod "dragGetData" o = Gtk.Widget.WidgetDragGetDataMethodInfo
    ResolveColumnMethod "dragHighlight" o = Gtk.Widget.WidgetDragHighlightMethodInfo
    ResolveColumnMethod "dragSourceAddImageTargets" o = Gtk.Widget.WidgetDragSourceAddImageTargetsMethodInfo
    ResolveColumnMethod "dragSourceAddTextTargets" o = Gtk.Widget.WidgetDragSourceAddTextTargetsMethodInfo
    ResolveColumnMethod "dragSourceAddUriTargets" o = Gtk.Widget.WidgetDragSourceAddUriTargetsMethodInfo
    ResolveColumnMethod "dragSourceGetTargetList" o = Gtk.Widget.WidgetDragSourceGetTargetListMethodInfo
    ResolveColumnMethod "dragSourceSet" o = Gtk.Widget.WidgetDragSourceSetMethodInfo
    ResolveColumnMethod "dragSourceSetIconGicon" o = Gtk.Widget.WidgetDragSourceSetIconGiconMethodInfo
    ResolveColumnMethod "dragSourceSetIconName" o = Gtk.Widget.WidgetDragSourceSetIconNameMethodInfo
    ResolveColumnMethod "dragSourceSetIconPixbuf" o = Gtk.Widget.WidgetDragSourceSetIconPixbufMethodInfo
    ResolveColumnMethod "dragSourceSetIconStock" o = Gtk.Widget.WidgetDragSourceSetIconStockMethodInfo
    ResolveColumnMethod "dragSourceSetTargetList" o = Gtk.Widget.WidgetDragSourceSetTargetListMethodInfo
    ResolveColumnMethod "dragSourceUnset" o = Gtk.Widget.WidgetDragSourceUnsetMethodInfo
    ResolveColumnMethod "dragUnhighlight" o = Gtk.Widget.WidgetDragUnhighlightMethodInfo
    ResolveColumnMethod "draw" o = Gtk.Widget.WidgetDrawMethodInfo
    ResolveColumnMethod "ensureStyle" o = Gtk.Widget.WidgetEnsureStyleMethodInfo
    ResolveColumnMethod "errorBell" o = Gtk.Widget.WidgetErrorBellMethodInfo
    ResolveColumnMethod "event" o = Gtk.Widget.WidgetEventMethodInfo
    ResolveColumnMethod "forall" o = Gtk.Container.ContainerForallMethodInfo
    ResolveColumnMethod "forceFloating" o = GObject.Object.ObjectForceFloatingMethodInfo
    ResolveColumnMethod "foreach" o = Gtk.Container.ContainerForeachMethodInfo
    ResolveColumnMethod "freezeChildNotify" o = Gtk.Widget.WidgetFreezeChildNotifyMethodInfo
    ResolveColumnMethod "freezeNotify" o = GObject.Object.ObjectFreezeNotifyMethodInfo
    ResolveColumnMethod "getv" o = GObject.Object.ObjectGetvMethodInfo
    ResolveColumnMethod "grabAdd" o = Gtk.Widget.WidgetGrabAddMethodInfo
    ResolveColumnMethod "grabDefault" o = Gtk.Widget.WidgetGrabDefaultMethodInfo
    ResolveColumnMethod "grabFocus" o = Gtk.Widget.WidgetGrabFocusMethodInfo
    ResolveColumnMethod "grabRemove" o = Gtk.Widget.WidgetGrabRemoveMethodInfo
    ResolveColumnMethod "hasDefault" o = Gtk.Widget.WidgetHasDefaultMethodInfo
    ResolveColumnMethod "hasFocus" o = Gtk.Widget.WidgetHasFocusMethodInfo
    ResolveColumnMethod "hasGrab" o = Gtk.Widget.WidgetHasGrabMethodInfo
    ResolveColumnMethod "hasRcStyle" o = Gtk.Widget.WidgetHasRcStyleMethodInfo
    ResolveColumnMethod "hasScreen" o = Gtk.Widget.WidgetHasScreenMethodInfo
    ResolveColumnMethod "hasVisibleFocus" o = Gtk.Widget.WidgetHasVisibleFocusMethodInfo
    ResolveColumnMethod "hide" o = Gtk.Widget.WidgetHideMethodInfo
    ResolveColumnMethod "hideOnDelete" o = Gtk.Widget.WidgetHideOnDeleteMethodInfo
    ResolveColumnMethod "inDestruction" o = Gtk.Widget.WidgetInDestructionMethodInfo
    ResolveColumnMethod "initTemplate" o = Gtk.Widget.WidgetInitTemplateMethodInfo
    ResolveColumnMethod "inputShapeCombineRegion" o = Gtk.Widget.WidgetInputShapeCombineRegionMethodInfo
    ResolveColumnMethod "insertActionGroup" o = Gtk.Widget.WidgetInsertActionGroupMethodInfo
    ResolveColumnMethod "intersect" o = Gtk.Widget.WidgetIntersectMethodInfo
    ResolveColumnMethod "isAncestor" o = Gtk.Widget.WidgetIsAncestorMethodInfo
    ResolveColumnMethod "isComposited" o = Gtk.Widget.WidgetIsCompositedMethodInfo
    ResolveColumnMethod "isDrawable" o = Gtk.Widget.WidgetIsDrawableMethodInfo
    ResolveColumnMethod "isFloating" o = GObject.Object.ObjectIsFloatingMethodInfo
    ResolveColumnMethod "isFocus" o = Gtk.Widget.WidgetIsFocusMethodInfo
    ResolveColumnMethod "isSensitive" o = Gtk.Widget.WidgetIsSensitiveMethodInfo
    ResolveColumnMethod "isToplevel" o = Gtk.Widget.WidgetIsToplevelMethodInfo
    ResolveColumnMethod "isVisible" o = Gtk.Widget.WidgetIsVisibleMethodInfo
    ResolveColumnMethod "keynavFailed" o = Gtk.Widget.WidgetKeynavFailedMethodInfo
    ResolveColumnMethod "listAccelClosures" o = Gtk.Widget.WidgetListAccelClosuresMethodInfo
    ResolveColumnMethod "listActionPrefixes" o = Gtk.Widget.WidgetListActionPrefixesMethodInfo
    ResolveColumnMethod "listMnemonicLabels" o = Gtk.Widget.WidgetListMnemonicLabelsMethodInfo
    ResolveColumnMethod "map" o = Gtk.Widget.WidgetMapMethodInfo
    ResolveColumnMethod "mnemonicActivate" o = Gtk.Widget.WidgetMnemonicActivateMethodInfo
    ResolveColumnMethod "modifyBase" o = Gtk.Widget.WidgetModifyBaseMethodInfo
    ResolveColumnMethod "modifyBg" o = Gtk.Widget.WidgetModifyBgMethodInfo
    ResolveColumnMethod "modifyCursor" o = Gtk.Widget.WidgetModifyCursorMethodInfo
    ResolveColumnMethod "modifyFg" o = Gtk.Widget.WidgetModifyFgMethodInfo
    ResolveColumnMethod "modifyFont" o = Gtk.Widget.WidgetModifyFontMethodInfo
    ResolveColumnMethod "modifyStyle" o = Gtk.Widget.WidgetModifyStyleMethodInfo
    ResolveColumnMethod "modifyText" o = Gtk.Widget.WidgetModifyTextMethodInfo
    ResolveColumnMethod "notify" o = GObject.Object.ObjectNotifyMethodInfo
    ResolveColumnMethod "notifyByPspec" o = GObject.Object.ObjectNotifyByPspecMethodInfo
    ResolveColumnMethod "overrideBackgroundColor" o = Gtk.Widget.WidgetOverrideBackgroundColorMethodInfo
    ResolveColumnMethod "overrideColor" o = Gtk.Widget.WidgetOverrideColorMethodInfo
    ResolveColumnMethod "overrideCursor" o = Gtk.Widget.WidgetOverrideCursorMethodInfo
    ResolveColumnMethod "overrideFont" o = Gtk.Widget.WidgetOverrideFontMethodInfo
    ResolveColumnMethod "overrideSymbolicColor" o = Gtk.Widget.WidgetOverrideSymbolicColorMethodInfo
    ResolveColumnMethod "parserFinished" o = Gtk.Buildable.BuildableParserFinishedMethodInfo
    ResolveColumnMethod "path" o = Gtk.Widget.WidgetPathMethodInfo
    ResolveColumnMethod "propagateDraw" o = Gtk.Container.ContainerPropagateDrawMethodInfo
    ResolveColumnMethod "queueAllocate" o = Gtk.Widget.WidgetQueueAllocateMethodInfo
    ResolveColumnMethod "queueComputeExpand" o = Gtk.Widget.WidgetQueueComputeExpandMethodInfo
    ResolveColumnMethod "queueDraw" o = Gtk.Widget.WidgetQueueDrawMethodInfo
    ResolveColumnMethod "queueDrawArea" o = Gtk.Widget.WidgetQueueDrawAreaMethodInfo
    ResolveColumnMethod "queueDrawRegion" o = Gtk.Widget.WidgetQueueDrawRegionMethodInfo
    ResolveColumnMethod "queueResize" o = Gtk.Widget.WidgetQueueResizeMethodInfo
    ResolveColumnMethod "queueResizeNoRedraw" o = Gtk.Widget.WidgetQueueResizeNoRedrawMethodInfo
    ResolveColumnMethod "realize" o = Gtk.Widget.WidgetRealizeMethodInfo
    ResolveColumnMethod "ref" o = GObject.Object.ObjectRefMethodInfo
    ResolveColumnMethod "refSink" o = GObject.Object.ObjectRefSinkMethodInfo
    ResolveColumnMethod "regionIntersect" o = Gtk.Widget.WidgetRegionIntersectMethodInfo
    ResolveColumnMethod "registerWindow" o = Gtk.Widget.WidgetRegisterWindowMethodInfo
    ResolveColumnMethod "remove" o = Gtk.Container.ContainerRemoveMethodInfo
    ResolveColumnMethod "removeAccelerator" o = Gtk.Widget.WidgetRemoveAcceleratorMethodInfo
    ResolveColumnMethod "removeMnemonicLabel" o = Gtk.Widget.WidgetRemoveMnemonicLabelMethodInfo
    ResolveColumnMethod "removeTickCallback" o = Gtk.Widget.WidgetRemoveTickCallbackMethodInfo
    ResolveColumnMethod "renderIcon" o = Gtk.Widget.WidgetRenderIconMethodInfo
    ResolveColumnMethod "renderIconPixbuf" o = Gtk.Widget.WidgetRenderIconPixbufMethodInfo
    ResolveColumnMethod "reparent" o = Gtk.Widget.WidgetReparentMethodInfo
    ResolveColumnMethod "resetRcStyles" o = Gtk.Widget.WidgetResetRcStylesMethodInfo
    ResolveColumnMethod "resetStyle" o = Gtk.Widget.WidgetResetStyleMethodInfo
    ResolveColumnMethod "resizeChildren" o = Gtk.Container.ContainerResizeChildrenMethodInfo
    ResolveColumnMethod "runDispose" o = GObject.Object.ObjectRunDisposeMethodInfo
    ResolveColumnMethod "sendExpose" o = Gtk.Widget.WidgetSendExposeMethodInfo
    ResolveColumnMethod "sendFocusChange" o = Gtk.Widget.WidgetSendFocusChangeMethodInfo
    ResolveColumnMethod "shapeCombineRegion" o = Gtk.Widget.WidgetShapeCombineRegionMethodInfo
    ResolveColumnMethod "show" o = Gtk.Widget.WidgetShowMethodInfo
    ResolveColumnMethod "showAll" o = Gtk.Widget.WidgetShowAllMethodInfo
    ResolveColumnMethod "showNow" o = Gtk.Widget.WidgetShowNowMethodInfo
    ResolveColumnMethod "sizeAllocate" o = Gtk.Widget.WidgetSizeAllocateMethodInfo
    ResolveColumnMethod "sizeAllocateWithBaseline" o = Gtk.Widget.WidgetSizeAllocateWithBaselineMethodInfo
    ResolveColumnMethod "sizeRequest" o = Gtk.Widget.WidgetSizeRequestMethodInfo
    ResolveColumnMethod "stealData" o = GObject.Object.ObjectStealDataMethodInfo
    ResolveColumnMethod "stealQdata" o = GObject.Object.ObjectStealQdataMethodInfo
    ResolveColumnMethod "styleAttach" o = Gtk.Widget.WidgetStyleAttachMethodInfo
    ResolveColumnMethod "styleGetProperty" o = Gtk.Widget.WidgetStyleGetPropertyMethodInfo
    ResolveColumnMethod "thawChildNotify" o = Gtk.Widget.WidgetThawChildNotifyMethodInfo
    ResolveColumnMethod "thawNotify" o = GObject.Object.ObjectThawNotifyMethodInfo
    ResolveColumnMethod "translateCoordinates" o = Gtk.Widget.WidgetTranslateCoordinatesMethodInfo
    ResolveColumnMethod "triggerTooltipQuery" o = Gtk.Widget.WidgetTriggerTooltipQueryMethodInfo
    ResolveColumnMethod "unmap" o = Gtk.Widget.WidgetUnmapMethodInfo
    ResolveColumnMethod "unparent" o = Gtk.Widget.WidgetUnparentMethodInfo
    ResolveColumnMethod "unrealize" o = Gtk.Widget.WidgetUnrealizeMethodInfo
    ResolveColumnMethod "unref" o = GObject.Object.ObjectUnrefMethodInfo
    ResolveColumnMethod "unregisterWindow" o = Gtk.Widget.WidgetUnregisterWindowMethodInfo
    ResolveColumnMethod "unsetFocusChain" o = Gtk.Container.ContainerUnsetFocusChainMethodInfo
    ResolveColumnMethod "unsetStateFlags" o = Gtk.Widget.WidgetUnsetStateFlagsMethodInfo
    ResolveColumnMethod "watchClosure" o = GObject.Object.ObjectWatchClosureMethodInfo
    ResolveColumnMethod "getAccessible" o = Gtk.Widget.WidgetGetAccessibleMethodInfo
    ResolveColumnMethod "getActionGroup" o = Gtk.Widget.WidgetGetActionGroupMethodInfo
    ResolveColumnMethod "getAllocatedBaseline" o = Gtk.Widget.WidgetGetAllocatedBaselineMethodInfo
    ResolveColumnMethod "getAllocatedHeight" o = Gtk.Widget.WidgetGetAllocatedHeightMethodInfo
    ResolveColumnMethod "getAllocatedSize" o = Gtk.Widget.WidgetGetAllocatedSizeMethodInfo
    ResolveColumnMethod "getAllocatedWidth" o = Gtk.Widget.WidgetGetAllocatedWidthMethodInfo
    ResolveColumnMethod "getAllocation" o = Gtk.Widget.WidgetGetAllocationMethodInfo
    ResolveColumnMethod "getAncestor" o = Gtk.Widget.WidgetGetAncestorMethodInfo
    ResolveColumnMethod "getAppPaintable" o = Gtk.Widget.WidgetGetAppPaintableMethodInfo
    ResolveColumnMethod "getBorderWidth" o = Gtk.Container.ContainerGetBorderWidthMethodInfo
    ResolveColumnMethod "getCanDefault" o = Gtk.Widget.WidgetGetCanDefaultMethodInfo
    ResolveColumnMethod "getCanFocus" o = Gtk.Widget.WidgetGetCanFocusMethodInfo
    ResolveColumnMethod "getChild" o = Gtk.Bin.BinGetChildMethodInfo
    ResolveColumnMethod "getChildRequisition" o = Gtk.Widget.WidgetGetChildRequisitionMethodInfo
    ResolveColumnMethod "getChildVisible" o = Gtk.Widget.WidgetGetChildVisibleMethodInfo
    ResolveColumnMethod "getChildren" o = Gtk.Container.ContainerGetChildrenMethodInfo
    ResolveColumnMethod "getClip" o = Gtk.Widget.WidgetGetClipMethodInfo
    ResolveColumnMethod "getClipboard" o = Gtk.Widget.WidgetGetClipboardMethodInfo
    ResolveColumnMethod "getCompositeName" o = Gtk.Widget.WidgetGetCompositeNameMethodInfo
    ResolveColumnMethod "getData" o = GObject.Object.ObjectGetDataMethodInfo
    ResolveColumnMethod "getDeviceEnabled" o = Gtk.Widget.WidgetGetDeviceEnabledMethodInfo
    ResolveColumnMethod "getDeviceEvents" o = Gtk.Widget.WidgetGetDeviceEventsMethodInfo
    ResolveColumnMethod "getDirection" o = Gtk.Widget.WidgetGetDirectionMethodInfo
    ResolveColumnMethod "getDisplay" o = Gtk.Widget.WidgetGetDisplayMethodInfo
    ResolveColumnMethod "getDoubleBuffered" o = Gtk.Widget.WidgetGetDoubleBufferedMethodInfo
    ResolveColumnMethod "getEvents" o = Gtk.Widget.WidgetGetEventsMethodInfo
    ResolveColumnMethod "getFocusChain" o = Gtk.Container.ContainerGetFocusChainMethodInfo
    ResolveColumnMethod "getFocusChild" o = Gtk.Container.ContainerGetFocusChildMethodInfo
    ResolveColumnMethod "getFocusHadjustment" o = Gtk.Container.ContainerGetFocusHadjustmentMethodInfo
    ResolveColumnMethod "getFocusOnClick" o = Gtk.Widget.WidgetGetFocusOnClickMethodInfo
    ResolveColumnMethod "getFocusVadjustment" o = Gtk.Container.ContainerGetFocusVadjustmentMethodInfo
    ResolveColumnMethod "getFontMap" o = Gtk.Widget.WidgetGetFontMapMethodInfo
    ResolveColumnMethod "getFontOptions" o = Gtk.Widget.WidgetGetFontOptionsMethodInfo
    ResolveColumnMethod "getFrameClock" o = Gtk.Widget.WidgetGetFrameClockMethodInfo
    ResolveColumnMethod "getHalign" o = Gtk.Widget.WidgetGetHalignMethodInfo
    ResolveColumnMethod "getHasTooltip" o = Gtk.Widget.WidgetGetHasTooltipMethodInfo
    ResolveColumnMethod "getHasWindow" o = Gtk.Widget.WidgetGetHasWindowMethodInfo
    ResolveColumnMethod "getHexpand" o = Gtk.Widget.WidgetGetHexpandMethodInfo
    ResolveColumnMethod "getHexpandSet" o = Gtk.Widget.WidgetGetHexpandSetMethodInfo
    ResolveColumnMethod "getInternalChild" o = Gtk.Buildable.BuildableGetInternalChildMethodInfo
    ResolveColumnMethod "getLinearGrowthWidth" o = ColumnGetLinearGrowthWidthMethodInfo
    ResolveColumnMethod "getMapped" o = Gtk.Widget.WidgetGetMappedMethodInfo
    ResolveColumnMethod "getMarginBottom" o = Gtk.Widget.WidgetGetMarginBottomMethodInfo
    ResolveColumnMethod "getMarginEnd" o = Gtk.Widget.WidgetGetMarginEndMethodInfo
    ResolveColumnMethod "getMarginLeft" o = Gtk.Widget.WidgetGetMarginLeftMethodInfo
    ResolveColumnMethod "getMarginRight" o = Gtk.Widget.WidgetGetMarginRightMethodInfo
    ResolveColumnMethod "getMarginStart" o = Gtk.Widget.WidgetGetMarginStartMethodInfo
    ResolveColumnMethod "getMarginTop" o = Gtk.Widget.WidgetGetMarginTopMethodInfo
    ResolveColumnMethod "getMaximumWidth" o = ColumnGetMaximumWidthMethodInfo
    ResolveColumnMethod "getModifierMask" o = Gtk.Widget.WidgetGetModifierMaskMethodInfo
    ResolveColumnMethod "getModifierStyle" o = Gtk.Widget.WidgetGetModifierStyleMethodInfo
    ResolveColumnMethod "getName" o = Gtk.Widget.WidgetGetNameMethodInfo
    ResolveColumnMethod "getNoShowAll" o = Gtk.Widget.WidgetGetNoShowAllMethodInfo
    ResolveColumnMethod "getOpacity" o = Gtk.Widget.WidgetGetOpacityMethodInfo
    ResolveColumnMethod "getPangoContext" o = Gtk.Widget.WidgetGetPangoContextMethodInfo
    ResolveColumnMethod "getParent" o = Gtk.Widget.WidgetGetParentMethodInfo
    ResolveColumnMethod "getParentWindow" o = Gtk.Widget.WidgetGetParentWindowMethodInfo
    ResolveColumnMethod "getPath" o = Gtk.Widget.WidgetGetPathMethodInfo
    ResolveColumnMethod "getPathForChild" o = Gtk.Container.ContainerGetPathForChildMethodInfo
    ResolveColumnMethod "getPointer" o = Gtk.Widget.WidgetGetPointerMethodInfo
    ResolveColumnMethod "getPreferredHeight" o = Gtk.Widget.WidgetGetPreferredHeightMethodInfo
    ResolveColumnMethod "getPreferredHeightAndBaselineForWidth" o = Gtk.Widget.WidgetGetPreferredHeightAndBaselineForWidthMethodInfo
    ResolveColumnMethod "getPreferredHeightForWidth" o = Gtk.Widget.WidgetGetPreferredHeightForWidthMethodInfo
    ResolveColumnMethod "getPreferredSize" o = Gtk.Widget.WidgetGetPreferredSizeMethodInfo
    ResolveColumnMethod "getPreferredWidth" o = Gtk.Widget.WidgetGetPreferredWidthMethodInfo
    ResolveColumnMethod "getPreferredWidthForHeight" o = Gtk.Widget.WidgetGetPreferredWidthForHeightMethodInfo
    ResolveColumnMethod "getProperty" o = GObject.Object.ObjectGetPropertyMethodInfo
    ResolveColumnMethod "getQdata" o = GObject.Object.ObjectGetQdataMethodInfo
    ResolveColumnMethod "getRealized" o = Gtk.Widget.WidgetGetRealizedMethodInfo
    ResolveColumnMethod "getReceivesDefault" o = Gtk.Widget.WidgetGetReceivesDefaultMethodInfo
    ResolveColumnMethod "getRequestMode" o = Gtk.Widget.WidgetGetRequestModeMethodInfo
    ResolveColumnMethod "getRequisition" o = Gtk.Widget.WidgetGetRequisitionMethodInfo
    ResolveColumnMethod "getResizeMode" o = Gtk.Container.ContainerGetResizeModeMethodInfo
    ResolveColumnMethod "getRootWindow" o = Gtk.Widget.WidgetGetRootWindowMethodInfo
    ResolveColumnMethod "getScaleFactor" o = Gtk.Widget.WidgetGetScaleFactorMethodInfo
    ResolveColumnMethod "getScreen" o = Gtk.Widget.WidgetGetScreenMethodInfo
    ResolveColumnMethod "getSensitive" o = Gtk.Widget.WidgetGetSensitiveMethodInfo
    ResolveColumnMethod "getSettings" o = Gtk.Widget.WidgetGetSettingsMethodInfo
    ResolveColumnMethod "getSizeRequest" o = Gtk.Widget.WidgetGetSizeRequestMethodInfo
    ResolveColumnMethod "getState" o = Gtk.Widget.WidgetGetStateMethodInfo
    ResolveColumnMethod "getStateFlags" o = Gtk.Widget.WidgetGetStateFlagsMethodInfo
    ResolveColumnMethod "getStyle" o = Gtk.Widget.WidgetGetStyleMethodInfo
    ResolveColumnMethod "getStyleContext" o = Gtk.Widget.WidgetGetStyleContextMethodInfo
    ResolveColumnMethod "getSupportMultidevice" o = Gtk.Widget.WidgetGetSupportMultideviceMethodInfo
    ResolveColumnMethod "getTemplateChild" o = Gtk.Widget.WidgetGetTemplateChildMethodInfo
    ResolveColumnMethod "getTooltipMarkup" o = Gtk.Widget.WidgetGetTooltipMarkupMethodInfo
    ResolveColumnMethod "getTooltipText" o = Gtk.Widget.WidgetGetTooltipTextMethodInfo
    ResolveColumnMethod "getTooltipWindow" o = Gtk.Widget.WidgetGetTooltipWindowMethodInfo
    ResolveColumnMethod "getToplevel" o = Gtk.Widget.WidgetGetToplevelMethodInfo
    ResolveColumnMethod "getValign" o = Gtk.Widget.WidgetGetValignMethodInfo
    ResolveColumnMethod "getValignWithBaseline" o = Gtk.Widget.WidgetGetValignWithBaselineMethodInfo
    ResolveColumnMethod "getVexpand" o = Gtk.Widget.WidgetGetVexpandMethodInfo
    ResolveColumnMethod "getVexpandSet" o = Gtk.Widget.WidgetGetVexpandSetMethodInfo
    ResolveColumnMethod "getVisible" o = Gtk.Widget.WidgetGetVisibleMethodInfo
    ResolveColumnMethod "getVisual" o = Gtk.Widget.WidgetGetVisualMethodInfo
    ResolveColumnMethod "getWindow" o = Gtk.Widget.WidgetGetWindowMethodInfo
    ResolveColumnMethod "setAccelPath" o = Gtk.Widget.WidgetSetAccelPathMethodInfo
    ResolveColumnMethod "setAllocation" o = Gtk.Widget.WidgetSetAllocationMethodInfo
    ResolveColumnMethod "setAppPaintable" o = Gtk.Widget.WidgetSetAppPaintableMethodInfo
    ResolveColumnMethod "setBorderWidth" o = Gtk.Container.ContainerSetBorderWidthMethodInfo
    ResolveColumnMethod "setBuildableProperty" o = Gtk.Buildable.BuildableSetBuildablePropertyMethodInfo
    ResolveColumnMethod "setCanDefault" o = Gtk.Widget.WidgetSetCanDefaultMethodInfo
    ResolveColumnMethod "setCanFocus" o = Gtk.Widget.WidgetSetCanFocusMethodInfo
    ResolveColumnMethod "setChildVisible" o = Gtk.Widget.WidgetSetChildVisibleMethodInfo
    ResolveColumnMethod "setClip" o = Gtk.Widget.WidgetSetClipMethodInfo
    ResolveColumnMethod "setCompositeName" o = Gtk.Widget.WidgetSetCompositeNameMethodInfo
    ResolveColumnMethod "setData" o = GObject.Object.ObjectSetDataMethodInfo
    ResolveColumnMethod "setDeviceEnabled" o = Gtk.Widget.WidgetSetDeviceEnabledMethodInfo
    ResolveColumnMethod "setDeviceEvents" o = Gtk.Widget.WidgetSetDeviceEventsMethodInfo
    ResolveColumnMethod "setDirection" o = Gtk.Widget.WidgetSetDirectionMethodInfo
    ResolveColumnMethod "setDoubleBuffered" o = Gtk.Widget.WidgetSetDoubleBufferedMethodInfo
    ResolveColumnMethod "setEvents" o = Gtk.Widget.WidgetSetEventsMethodInfo
    ResolveColumnMethod "setFocusChain" o = Gtk.Container.ContainerSetFocusChainMethodInfo
    ResolveColumnMethod "setFocusChild" o = Gtk.Container.ContainerSetFocusChildMethodInfo
    ResolveColumnMethod "setFocusHadjustment" o = Gtk.Container.ContainerSetFocusHadjustmentMethodInfo
    ResolveColumnMethod "setFocusOnClick" o = Gtk.Widget.WidgetSetFocusOnClickMethodInfo
    ResolveColumnMethod "setFocusVadjustment" o = Gtk.Container.ContainerSetFocusVadjustmentMethodInfo
    ResolveColumnMethod "setFontMap" o = Gtk.Widget.WidgetSetFontMapMethodInfo
    ResolveColumnMethod "setFontOptions" o = Gtk.Widget.WidgetSetFontOptionsMethodInfo
    ResolveColumnMethod "setHalign" o = Gtk.Widget.WidgetSetHalignMethodInfo
    ResolveColumnMethod "setHasTooltip" o = Gtk.Widget.WidgetSetHasTooltipMethodInfo
    ResolveColumnMethod "setHasWindow" o = Gtk.Widget.WidgetSetHasWindowMethodInfo
    ResolveColumnMethod "setHexpand" o = Gtk.Widget.WidgetSetHexpandMethodInfo
    ResolveColumnMethod "setHexpandSet" o = Gtk.Widget.WidgetSetHexpandSetMethodInfo
    ResolveColumnMethod "setLinearGrowthWidth" o = ColumnSetLinearGrowthWidthMethodInfo
    ResolveColumnMethod "setMapped" o = Gtk.Widget.WidgetSetMappedMethodInfo
    ResolveColumnMethod "setMarginBottom" o = Gtk.Widget.WidgetSetMarginBottomMethodInfo
    ResolveColumnMethod "setMarginEnd" o = Gtk.Widget.WidgetSetMarginEndMethodInfo
    ResolveColumnMethod "setMarginLeft" o = Gtk.Widget.WidgetSetMarginLeftMethodInfo
    ResolveColumnMethod "setMarginRight" o = Gtk.Widget.WidgetSetMarginRightMethodInfo
    ResolveColumnMethod "setMarginStart" o = Gtk.Widget.WidgetSetMarginStartMethodInfo
    ResolveColumnMethod "setMarginTop" o = Gtk.Widget.WidgetSetMarginTopMethodInfo
    ResolveColumnMethod "setMaximumWidth" o = ColumnSetMaximumWidthMethodInfo
    ResolveColumnMethod "setName" o = Gtk.Widget.WidgetSetNameMethodInfo
    ResolveColumnMethod "setNoShowAll" o = Gtk.Widget.WidgetSetNoShowAllMethodInfo
    ResolveColumnMethod "setOpacity" o = Gtk.Widget.WidgetSetOpacityMethodInfo
    ResolveColumnMethod "setParent" o = Gtk.Widget.WidgetSetParentMethodInfo
    ResolveColumnMethod "setParentWindow" o = Gtk.Widget.WidgetSetParentWindowMethodInfo
    ResolveColumnMethod "setProperty" o = GObject.Object.ObjectSetPropertyMethodInfo
    ResolveColumnMethod "setRealized" o = Gtk.Widget.WidgetSetRealizedMethodInfo
    ResolveColumnMethod "setReallocateRedraws" o = Gtk.Container.ContainerSetReallocateRedrawsMethodInfo
    ResolveColumnMethod "setReceivesDefault" o = Gtk.Widget.WidgetSetReceivesDefaultMethodInfo
    ResolveColumnMethod "setRedrawOnAllocate" o = Gtk.Widget.WidgetSetRedrawOnAllocateMethodInfo
    ResolveColumnMethod "setResizeMode" o = Gtk.Container.ContainerSetResizeModeMethodInfo
    ResolveColumnMethod "setSensitive" o = Gtk.Widget.WidgetSetSensitiveMethodInfo
    ResolveColumnMethod "setSizeRequest" o = Gtk.Widget.WidgetSetSizeRequestMethodInfo
    ResolveColumnMethod "setState" o = Gtk.Widget.WidgetSetStateMethodInfo
    ResolveColumnMethod "setStateFlags" o = Gtk.Widget.WidgetSetStateFlagsMethodInfo
    ResolveColumnMethod "setStyle" o = Gtk.Widget.WidgetSetStyleMethodInfo
    ResolveColumnMethod "setSupportMultidevice" o = Gtk.Widget.WidgetSetSupportMultideviceMethodInfo
    ResolveColumnMethod "setTooltipMarkup" o = Gtk.Widget.WidgetSetTooltipMarkupMethodInfo
    ResolveColumnMethod "setTooltipText" o = Gtk.Widget.WidgetSetTooltipTextMethodInfo
    ResolveColumnMethod "setTooltipWindow" o = Gtk.Widget.WidgetSetTooltipWindowMethodInfo
    ResolveColumnMethod "setValign" o = Gtk.Widget.WidgetSetValignMethodInfo
    ResolveColumnMethod "setVexpand" o = Gtk.Widget.WidgetSetVexpandMethodInfo
    ResolveColumnMethod "setVexpandSet" o = Gtk.Widget.WidgetSetVexpandSetMethodInfo
    ResolveColumnMethod "setVisible" o = Gtk.Widget.WidgetSetVisibleMethodInfo
    ResolveColumnMethod "setVisual" o = Gtk.Widget.WidgetSetVisualMethodInfo
    ResolveColumnMethod "setWindow" o = Gtk.Widget.WidgetSetWindowMethodInfo
    ResolveColumnMethod l o = O.MethodResolutionFailed l o

instance (info ~ ResolveColumnMethod t Column, O.MethodInfo info Column p) => OL.IsLabel t (Column -> p) where
#if MIN_VERSION_base(4,10,0)
    fromLabel = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#else
    fromLabel _ = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#endif

#endif

-- VVV Prop "linear-growth-width"
   -- Type: TBasicType TInt
   -- Flags: [PropertyReadable,PropertyWritable]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@linear-growth-width@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' column #linearGrowthWidth
@
-}
getColumnLinearGrowthWidth :: (MonadIO m, IsColumn o) => o -> m Int32
getColumnLinearGrowthWidth obj = liftIO $ B.Properties.getObjectPropertyInt32 obj "linear-growth-width"

{- |
Set the value of the “@linear-growth-width@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' column [ #linearGrowthWidth 'Data.GI.Base.Attributes.:=' value ]
@
-}
setColumnLinearGrowthWidth :: (MonadIO m, IsColumn o) => o -> Int32 -> m ()
setColumnLinearGrowthWidth obj val = liftIO $ B.Properties.setObjectPropertyInt32 obj "linear-growth-width" val

{- |
Construct a `GValueConstruct` with valid value for the “@linear-growth-width@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructColumnLinearGrowthWidth :: (IsColumn o) => Int32 -> IO (GValueConstruct o)
constructColumnLinearGrowthWidth val = B.Properties.constructObjectPropertyInt32 "linear-growth-width" val

#if ENABLE_OVERLOADING
data ColumnLinearGrowthWidthPropertyInfo
instance AttrInfo ColumnLinearGrowthWidthPropertyInfo where
    type AttrAllowedOps ColumnLinearGrowthWidthPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint ColumnLinearGrowthWidthPropertyInfo = (~) Int32
    type AttrBaseTypeConstraint ColumnLinearGrowthWidthPropertyInfo = IsColumn
    type AttrGetType ColumnLinearGrowthWidthPropertyInfo = Int32
    type AttrLabel ColumnLinearGrowthWidthPropertyInfo = "linear-growth-width"
    type AttrOrigin ColumnLinearGrowthWidthPropertyInfo = Column
    attrGet _ = getColumnLinearGrowthWidth
    attrSet _ = setColumnLinearGrowthWidth
    attrConstruct _ = constructColumnLinearGrowthWidth
    attrClear _ = undefined
#endif

-- VVV Prop "maximum-width"
   -- Type: TBasicType TInt
   -- Flags: [PropertyReadable,PropertyWritable]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@maximum-width@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' column #maximumWidth
@
-}
getColumnMaximumWidth :: (MonadIO m, IsColumn o) => o -> m Int32
getColumnMaximumWidth obj = liftIO $ B.Properties.getObjectPropertyInt32 obj "maximum-width"

{- |
Set the value of the “@maximum-width@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' column [ #maximumWidth 'Data.GI.Base.Attributes.:=' value ]
@
-}
setColumnMaximumWidth :: (MonadIO m, IsColumn o) => o -> Int32 -> m ()
setColumnMaximumWidth obj val = liftIO $ B.Properties.setObjectPropertyInt32 obj "maximum-width" val

{- |
Construct a `GValueConstruct` with valid value for the “@maximum-width@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructColumnMaximumWidth :: (IsColumn o) => Int32 -> IO (GValueConstruct o)
constructColumnMaximumWidth val = B.Properties.constructObjectPropertyInt32 "maximum-width" val

#if ENABLE_OVERLOADING
data ColumnMaximumWidthPropertyInfo
instance AttrInfo ColumnMaximumWidthPropertyInfo where
    type AttrAllowedOps ColumnMaximumWidthPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint ColumnMaximumWidthPropertyInfo = (~) Int32
    type AttrBaseTypeConstraint ColumnMaximumWidthPropertyInfo = IsColumn
    type AttrGetType ColumnMaximumWidthPropertyInfo = Int32
    type AttrLabel ColumnMaximumWidthPropertyInfo = "maximum-width"
    type AttrOrigin ColumnMaximumWidthPropertyInfo = Column
    attrGet _ = getColumnMaximumWidth
    attrSet _ = setColumnMaximumWidth
    attrConstruct _ = constructColumnMaximumWidth
    attrClear _ = undefined
#endif

#if ENABLE_OVERLOADING
instance O.HasAttributeList Column
type instance O.AttributeList Column = ColumnAttributeList
type ColumnAttributeList = ('[ '("appPaintable", Gtk.Widget.WidgetAppPaintablePropertyInfo), '("borderWidth", Gtk.Container.ContainerBorderWidthPropertyInfo), '("canDefault", Gtk.Widget.WidgetCanDefaultPropertyInfo), '("canFocus", Gtk.Widget.WidgetCanFocusPropertyInfo), '("child", Gtk.Container.ContainerChildPropertyInfo), '("compositeChild", Gtk.Widget.WidgetCompositeChildPropertyInfo), '("doubleBuffered", Gtk.Widget.WidgetDoubleBufferedPropertyInfo), '("events", Gtk.Widget.WidgetEventsPropertyInfo), '("expand", Gtk.Widget.WidgetExpandPropertyInfo), '("focusOnClick", Gtk.Widget.WidgetFocusOnClickPropertyInfo), '("halign", Gtk.Widget.WidgetHalignPropertyInfo), '("hasDefault", Gtk.Widget.WidgetHasDefaultPropertyInfo), '("hasFocus", Gtk.Widget.WidgetHasFocusPropertyInfo), '("hasTooltip", Gtk.Widget.WidgetHasTooltipPropertyInfo), '("heightRequest", Gtk.Widget.WidgetHeightRequestPropertyInfo), '("hexpand", Gtk.Widget.WidgetHexpandPropertyInfo), '("hexpandSet", Gtk.Widget.WidgetHexpandSetPropertyInfo), '("isFocus", Gtk.Widget.WidgetIsFocusPropertyInfo), '("linearGrowthWidth", ColumnLinearGrowthWidthPropertyInfo), '("margin", Gtk.Widget.WidgetMarginPropertyInfo), '("marginBottom", Gtk.Widget.WidgetMarginBottomPropertyInfo), '("marginEnd", Gtk.Widget.WidgetMarginEndPropertyInfo), '("marginLeft", Gtk.Widget.WidgetMarginLeftPropertyInfo), '("marginRight", Gtk.Widget.WidgetMarginRightPropertyInfo), '("marginStart", Gtk.Widget.WidgetMarginStartPropertyInfo), '("marginTop", Gtk.Widget.WidgetMarginTopPropertyInfo), '("maximumWidth", ColumnMaximumWidthPropertyInfo), '("name", Gtk.Widget.WidgetNamePropertyInfo), '("noShowAll", Gtk.Widget.WidgetNoShowAllPropertyInfo), '("opacity", Gtk.Widget.WidgetOpacityPropertyInfo), '("parent", Gtk.Widget.WidgetParentPropertyInfo), '("receivesDefault", Gtk.Widget.WidgetReceivesDefaultPropertyInfo), '("resizeMode", Gtk.Container.ContainerResizeModePropertyInfo), '("scaleFactor", Gtk.Widget.WidgetScaleFactorPropertyInfo), '("sensitive", Gtk.Widget.WidgetSensitivePropertyInfo), '("style", Gtk.Widget.WidgetStylePropertyInfo), '("tooltipMarkup", Gtk.Widget.WidgetTooltipMarkupPropertyInfo), '("tooltipText", Gtk.Widget.WidgetTooltipTextPropertyInfo), '("valign", Gtk.Widget.WidgetValignPropertyInfo), '("vexpand", Gtk.Widget.WidgetVexpandPropertyInfo), '("vexpandSet", Gtk.Widget.WidgetVexpandSetPropertyInfo), '("visible", Gtk.Widget.WidgetVisiblePropertyInfo), '("widthRequest", Gtk.Widget.WidgetWidthRequestPropertyInfo), '("window", Gtk.Widget.WidgetWindowPropertyInfo)] :: [(Symbol, *)])
#endif

#if ENABLE_OVERLOADING
columnLinearGrowthWidth :: AttrLabelProxy "linearGrowthWidth"
columnLinearGrowthWidth = AttrLabelProxy

columnMaximumWidth :: AttrLabelProxy "maximumWidth"
columnMaximumWidth = AttrLabelProxy

#endif

#if ENABLE_OVERLOADING
type instance O.SignalList Column = ColumnSignalList
type ColumnSignalList = ('[ '("accelClosuresChanged", Gtk.Widget.WidgetAccelClosuresChangedSignalInfo), '("add", Gtk.Container.ContainerAddSignalInfo), '("buttonPressEvent", Gtk.Widget.WidgetButtonPressEventSignalInfo), '("buttonReleaseEvent", Gtk.Widget.WidgetButtonReleaseEventSignalInfo), '("canActivateAccel", Gtk.Widget.WidgetCanActivateAccelSignalInfo), '("checkResize", Gtk.Container.ContainerCheckResizeSignalInfo), '("childNotify", Gtk.Widget.WidgetChildNotifySignalInfo), '("compositedChanged", Gtk.Widget.WidgetCompositedChangedSignalInfo), '("configureEvent", Gtk.Widget.WidgetConfigureEventSignalInfo), '("damageEvent", Gtk.Widget.WidgetDamageEventSignalInfo), '("deleteEvent", Gtk.Widget.WidgetDeleteEventSignalInfo), '("destroy", Gtk.Widget.WidgetDestroySignalInfo), '("destroyEvent", Gtk.Widget.WidgetDestroyEventSignalInfo), '("directionChanged", Gtk.Widget.WidgetDirectionChangedSignalInfo), '("dragBegin", Gtk.Widget.WidgetDragBeginSignalInfo), '("dragDataDelete", Gtk.Widget.WidgetDragDataDeleteSignalInfo), '("dragDataGet", Gtk.Widget.WidgetDragDataGetSignalInfo), '("dragDataReceived", Gtk.Widget.WidgetDragDataReceivedSignalInfo), '("dragDrop", Gtk.Widget.WidgetDragDropSignalInfo), '("dragEnd", Gtk.Widget.WidgetDragEndSignalInfo), '("dragFailed", Gtk.Widget.WidgetDragFailedSignalInfo), '("dragLeave", Gtk.Widget.WidgetDragLeaveSignalInfo), '("dragMotion", Gtk.Widget.WidgetDragMotionSignalInfo), '("draw", Gtk.Widget.WidgetDrawSignalInfo), '("enterNotifyEvent", Gtk.Widget.WidgetEnterNotifyEventSignalInfo), '("event", Gtk.Widget.WidgetEventSignalInfo), '("eventAfter", Gtk.Widget.WidgetEventAfterSignalInfo), '("focus", Gtk.Widget.WidgetFocusSignalInfo), '("focusInEvent", Gtk.Widget.WidgetFocusInEventSignalInfo), '("focusOutEvent", Gtk.Widget.WidgetFocusOutEventSignalInfo), '("grabBrokenEvent", Gtk.Widget.WidgetGrabBrokenEventSignalInfo), '("grabFocus", Gtk.Widget.WidgetGrabFocusSignalInfo), '("grabNotify", Gtk.Widget.WidgetGrabNotifySignalInfo), '("hide", Gtk.Widget.WidgetHideSignalInfo), '("hierarchyChanged", Gtk.Widget.WidgetHierarchyChangedSignalInfo), '("keyPressEvent", Gtk.Widget.WidgetKeyPressEventSignalInfo), '("keyReleaseEvent", Gtk.Widget.WidgetKeyReleaseEventSignalInfo), '("keynavFailed", Gtk.Widget.WidgetKeynavFailedSignalInfo), '("leaveNotifyEvent", Gtk.Widget.WidgetLeaveNotifyEventSignalInfo), '("map", Gtk.Widget.WidgetMapSignalInfo), '("mapEvent", Gtk.Widget.WidgetMapEventSignalInfo), '("mnemonicActivate", Gtk.Widget.WidgetMnemonicActivateSignalInfo), '("motionNotifyEvent", Gtk.Widget.WidgetMotionNotifyEventSignalInfo), '("moveFocus", Gtk.Widget.WidgetMoveFocusSignalInfo), '("notify", GObject.Object.ObjectNotifySignalInfo), '("parentSet", Gtk.Widget.WidgetParentSetSignalInfo), '("popupMenu", Gtk.Widget.WidgetPopupMenuSignalInfo), '("propertyNotifyEvent", Gtk.Widget.WidgetPropertyNotifyEventSignalInfo), '("proximityInEvent", Gtk.Widget.WidgetProximityInEventSignalInfo), '("proximityOutEvent", Gtk.Widget.WidgetProximityOutEventSignalInfo), '("queryTooltip", Gtk.Widget.WidgetQueryTooltipSignalInfo), '("realize", Gtk.Widget.WidgetRealizeSignalInfo), '("remove", Gtk.Container.ContainerRemoveSignalInfo), '("screenChanged", Gtk.Widget.WidgetScreenChangedSignalInfo), '("scrollEvent", Gtk.Widget.WidgetScrollEventSignalInfo), '("selectionClearEvent", Gtk.Widget.WidgetSelectionClearEventSignalInfo), '("selectionGet", Gtk.Widget.WidgetSelectionGetSignalInfo), '("selectionNotifyEvent", Gtk.Widget.WidgetSelectionNotifyEventSignalInfo), '("selectionReceived", Gtk.Widget.WidgetSelectionReceivedSignalInfo), '("selectionRequestEvent", Gtk.Widget.WidgetSelectionRequestEventSignalInfo), '("setFocusChild", Gtk.Container.ContainerSetFocusChildSignalInfo), '("show", Gtk.Widget.WidgetShowSignalInfo), '("showHelp", Gtk.Widget.WidgetShowHelpSignalInfo), '("sizeAllocate", Gtk.Widget.WidgetSizeAllocateSignalInfo), '("stateChanged", Gtk.Widget.WidgetStateChangedSignalInfo), '("stateFlagsChanged", Gtk.Widget.WidgetStateFlagsChangedSignalInfo), '("styleSet", Gtk.Widget.WidgetStyleSetSignalInfo), '("styleUpdated", Gtk.Widget.WidgetStyleUpdatedSignalInfo), '("touchEvent", Gtk.Widget.WidgetTouchEventSignalInfo), '("unmap", Gtk.Widget.WidgetUnmapSignalInfo), '("unmapEvent", Gtk.Widget.WidgetUnmapEventSignalInfo), '("unrealize", Gtk.Widget.WidgetUnrealizeSignalInfo), '("visibilityNotifyEvent", Gtk.Widget.WidgetVisibilityNotifyEventSignalInfo), '("windowStateEvent", Gtk.Widget.WidgetWindowStateEventSignalInfo)] :: [(Symbol, *)])

#endif

-- method Column::new
-- method type : Constructor
-- Args : []
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "Handy", name = "Column"}))
-- throws : False
-- Skip return : False

foreign import ccall "hdy_column_new" hdy_column_new :: 
    IO (Ptr Column)

{- |
Creates a new 'GI.Handy.Objects.Column.Column'.
-}
columnNew ::
    (B.CallStack.HasCallStack, MonadIO m) =>
    m Column
    {- ^ __Returns:__ a new 'GI.Handy.Objects.Column.Column' -}
columnNew  = liftIO $ do
    result <- hdy_column_new
    checkUnexpectedReturnNULL "columnNew" result
    result' <- (newObject Column) result
    return result'

#if ENABLE_OVERLOADING
#endif

-- method Column::get_linear_growth_width
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "Handy", name = "Column"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #HdyColumn", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TInt)
-- throws : False
-- Skip return : False

foreign import ccall "hdy_column_get_linear_growth_width" hdy_column_get_linear_growth_width :: 
    Ptr Column ->                           -- self : TInterface (Name {namespace = "Handy", name = "Column"})
    IO Int32

{- |
Gets the width up to which the child will be allocated all the available
width and starting from which it will be allocated a portion of the available
width. In bith cases the allocated width won\'t exceed the declared maximum.
-}
columnGetLinearGrowthWidth ::
    (B.CallStack.HasCallStack, MonadIO m, IsColumn a) =>
    a
    {- ^ /@self@/: a 'GI.Handy.Objects.Column.Column' -}
    -> m Int32
    {- ^ __Returns:__ the width up to which the child will be allocated all the available
width. -}
columnGetLinearGrowthWidth self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- hdy_column_get_linear_growth_width self'
    touchManagedPtr self
    return result

#if ENABLE_OVERLOADING
data ColumnGetLinearGrowthWidthMethodInfo
instance (signature ~ (m Int32), MonadIO m, IsColumn a) => O.MethodInfo ColumnGetLinearGrowthWidthMethodInfo a signature where
    overloadedMethod _ = columnGetLinearGrowthWidth

#endif

-- method Column::get_maximum_width
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "Handy", name = "Column"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #HdyColumn", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TInt)
-- throws : False
-- Skip return : False

foreign import ccall "hdy_column_get_maximum_width" hdy_column_get_maximum_width :: 
    Ptr Column ->                           -- self : TInterface (Name {namespace = "Handy", name = "Column"})
    IO Int32

{- |
Gets the maximum width to allocate to the contained child.
-}
columnGetMaximumWidth ::
    (B.CallStack.HasCallStack, MonadIO m, IsColumn a) =>
    a
    {- ^ /@self@/: a 'GI.Handy.Objects.Column.Column' -}
    -> m Int32
    {- ^ __Returns:__ the maximum width to allocate to the contained child. -}
columnGetMaximumWidth self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- hdy_column_get_maximum_width self'
    touchManagedPtr self
    return result

#if ENABLE_OVERLOADING
data ColumnGetMaximumWidthMethodInfo
instance (signature ~ (m Int32), MonadIO m, IsColumn a) => O.MethodInfo ColumnGetMaximumWidthMethodInfo a signature where
    overloadedMethod _ = columnGetMaximumWidth

#endif

-- method Column::set_linear_growth_width
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "Handy", name = "Column"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #HdyColumn", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "linear_growth_width", argType = TBasicType TInt, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "the linear growth width", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "hdy_column_set_linear_growth_width" hdy_column_set_linear_growth_width :: 
    Ptr Column ->                           -- self : TInterface (Name {namespace = "Handy", name = "Column"})
    Int32 ->                                -- linear_growth_width : TBasicType TInt
    IO ()

{- |
Sets the width up to which the child will be allocated all the available
width and starting from which it will be allocated a portion of the available
width. In bith cases the allocated width won\'t exceed the declared maximum.
-}
columnSetLinearGrowthWidth ::
    (B.CallStack.HasCallStack, MonadIO m, IsColumn a) =>
    a
    {- ^ /@self@/: a 'GI.Handy.Objects.Column.Column' -}
    -> Int32
    {- ^ /@linearGrowthWidth@/: the linear growth width -}
    -> m ()
columnSetLinearGrowthWidth self linearGrowthWidth = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    hdy_column_set_linear_growth_width self' linearGrowthWidth
    touchManagedPtr self
    return ()

#if ENABLE_OVERLOADING
data ColumnSetLinearGrowthWidthMethodInfo
instance (signature ~ (Int32 -> m ()), MonadIO m, IsColumn a) => O.MethodInfo ColumnSetLinearGrowthWidthMethodInfo a signature where
    overloadedMethod _ = columnSetLinearGrowthWidth

#endif

-- method Column::set_maximum_width
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "Handy", name = "Column"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #HdyColumn", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "maximum_width", argType = TBasicType TInt, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "the maximum width", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "hdy_column_set_maximum_width" hdy_column_set_maximum_width :: 
    Ptr Column ->                           -- self : TInterface (Name {namespace = "Handy", name = "Column"})
    Int32 ->                                -- maximum_width : TBasicType TInt
    IO ()

{- |
Sets the maximum width to allocate to the contained child.
-}
columnSetMaximumWidth ::
    (B.CallStack.HasCallStack, MonadIO m, IsColumn a) =>
    a
    {- ^ /@self@/: a 'GI.Handy.Objects.Column.Column' -}
    -> Int32
    {- ^ /@maximumWidth@/: the maximum width -}
    -> m ()
columnSetMaximumWidth self maximumWidth = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    hdy_column_set_maximum_width self' maximumWidth
    touchManagedPtr self
    return ()

#if ENABLE_OVERLOADING
data ColumnSetMaximumWidthMethodInfo
instance (signature ~ (Int32 -> m ()), MonadIO m, IsColumn a) => O.MethodInfo ColumnSetMaximumWidthMethodInfo a signature where
    overloadedMethod _ = columnSetMaximumWidth

#endif


